/* file.c generated by valac 0.56.14, the Vala compiler
 * generated from file.vala, do not modify */

/* Disk file handling

   Copyright (c) 1997-2021 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <pwd.h>
#include <unistd.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include <estr.h>
#include <sys/types.h>
#include <fcntl.h>
#include <gio/gio.h>
#include <sys/stat.h>
#include <errno.h>
#include <gee.h>

#define GETKEY_DEFAULT -1
#define KBD_RET ((Keystroke) 00403)
#define KBD_DEL ((Keystroke) 00410)
#define KBD_CTRL ((Keystroke) 01000)
#define KBD_CANCEL (KBD_CTRL | 'g')
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_BUFFER (buffer_get_type ())
#define BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUFFER, Buffer))
#define BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUFFER, BufferClass))
#define IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUFFER))
#define IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUFFER))
#define BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUFFER, BufferClass))

typedef struct _Buffer Buffer;
typedef struct _BufferClass BufferClass;
#define _buffer_unref0(var) ((var == NULL) ? NULL : (var = (buffer_unref (var), NULL)))
typedef struct _BufferPrivate BufferPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define MARKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MARKER, MarkerClass))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define IS_MARKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MARKER))
#define MARKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MARKER, MarkerClass))

typedef struct _Marker Marker;
typedef struct _MarkerClass MarkerClass;

#define TYPE_UNDO (undo_get_type ())
#define UNDO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO, Undo))
#define UNDO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO, UndoClass))
#define IS_UNDO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO))
#define IS_UNDO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO))
#define UNDO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO, UndoClass))

typedef struct _Undo Undo;
typedef struct _UndoClass UndoClass;

#define TYPE_VAR_ENTRY (var_entry_get_type ())
#define VAR_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VAR_ENTRY, VarEntry))
#define VAR_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VAR_ENTRY, VarEntryClass))
#define IS_VAR_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VAR_ENTRY))
#define IS_VAR_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VAR_ENTRY))
#define VAR_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VAR_ENTRY, VarEntryClass))

typedef struct _VarEntry VarEntry;
typedef struct _VarEntryClass VarEntryClass;
#define _immutable_estr_unref0(var) ((var == NULL) ? NULL : (var = (immutable_estr_unref (var), NULL)))
typedef enum  {
	FLAGS_NEED_RESYNC = 1 << 0,
	FLAGS_SET_UNIARG = 1 << 1,
	FLAGS_UNIARG_EMPTY = 1 << 2,
	FLAGS_DEFINING_MACRO = 1 << 3
} Flags;

#define TYPE_FLAGS (flags_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef guint Keystroke;
typedef gboolean (*Function) (glong uniarg, GeeQueue* args);

#define TYPE_LISP_FUNC (lisp_func_get_type ())
#define LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LISP_FUNC, LispFunc))
#define LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LISP_FUNC, LispFuncClass))
#define IS_LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LISP_FUNC))
#define IS_LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LISP_FUNC))
#define LISP_FUNC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LISP_FUNC, LispFuncClass))

typedef struct _LispFunc LispFunc;
typedef struct _LispFuncClass LispFuncClass;
#define _lisp_func_unref0(var) ((var == NULL) ? NULL : (var = (lisp_func_unref (var), NULL)))
typedef struct _LispFuncPrivate LispFuncPrivate;

#define TYPE_COMPLETION (completion_get_type ())
#define COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION, Completion))
#define COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION, CompletionClass))
#define IS_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION))
#define IS_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION))
#define COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION, CompletionClass))

typedef struct _Completion Completion;
typedef struct _CompletionClass CompletionClass;

#define TYPE_HISTORY (history_get_type ())
#define HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY, History))
#define HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY, HistoryClass))
#define IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY))
#define IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY))
#define HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY, HistoryClass))

typedef struct _History History;
typedef struct _HistoryClass HistoryClass;
#define _completion_unref0(var) ((var == NULL) ? NULL : (var = (completion_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Buffer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BufferPrivate * priv;
	gchar* name;
	gchar* filename;
	Buffer* next;
	gsize goalc;
	Marker* mark;
	Marker* markers;
	GList* last_undop;
	GList* next_undop;
	GHashTable* vars;
	gboolean modified;
	gboolean nosave;
	gboolean needname;
	gboolean temporary;
	gboolean readonly;
	gboolean backup;
	gboolean noundo;
	gboolean autofill;
	gboolean isearch;
	gboolean mark_active;
	gchar* dir;
};

struct _BufferClass {
	GTypeClass parent_class;
	void (*finalize) (Buffer *self);
	gsize (*get_length) (Buffer* self);
	const gchar* (*get_eol) (Buffer* self);
};

struct _LispFunc {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LispFuncPrivate * priv;
	gchar* name;
	Function func;
	gboolean interactive;
	gchar* doc;
};

struct _LispFuncClass {
	GTypeClass parent_class;
	void (*finalize) (LispFunc *self);
};

VALA_EXTERN Buffer* head_bp;
VALA_EXTERN Flags thisflag;
VALA_EXTERN Buffer* cur_bp;

VALA_EXTERN gchar* expand_path (const gchar* path);
VALA_EXTERN gchar* compact_path (const gchar* in_path);
VALA_EXTERN gboolean check_writable (const gchar* filename);
VALA_EXTERN gboolean find_file (const gchar* filename);
VALA_EXTERN gpointer buffer_ref (gpointer instance);
VALA_EXTERN void buffer_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_buffer (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_buffer (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_buffer (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_buffer (const GValue* value);
VALA_EXTERN GType buffer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Buffer, buffer_unref)
VALA_EXTERN gpointer marker_ref (gpointer instance);
VALA_EXTERN void marker_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_marker (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_marker (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_marker (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_marker (const GValue* value);
VALA_EXTERN GType marker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Marker, marker_unref)
VALA_EXTERN gpointer undo_ref (gpointer instance);
VALA_EXTERN void undo_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_undo (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
VALA_EXTERN void value_set_undo (GValue* value,
                     gpointer v_object);
VALA_EXTERN void value_take_undo (GValue* value,
                      gpointer v_object);
VALA_EXTERN gpointer value_get_undo (const GValue* value);
VALA_EXTERN GType undo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Undo, undo_unref)
VALA_EXTERN gpointer var_entry_ref (gpointer instance);
VALA_EXTERN void var_entry_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_var_entry (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_var_entry (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_var_entry (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_var_entry (const GValue* value);
VALA_EXTERN GType var_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VarEntry, var_entry_unref)
VALA_EXTERN void minibuf_error (const gchar* fmt,
                    ...);
VALA_EXTERN Buffer* buffer_new (Estr* es);
VALA_EXTERN Buffer* buffer_construct (GType object_type,
                          Estr* es);
VALA_EXTERN void buffer_set_names (Buffer* self,
                       const gchar* new_filename);
VALA_EXTERN void buffer_switch_to (Buffer* self);
VALA_EXTERN GType flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gint write_all (gint fd,
                gchar* data,
                gsize length);
VALA_EXTERN gint write_to_disk (Buffer* bp,
                    const gchar* filename,
                    mode_t mode);
VALA_EXTERN ImmutableEstr* buffer_pre_point (Buffer* self);
VALA_EXTERN ImmutableEstr* buffer_post_point (Buffer* self);
VALA_EXTERN gchar* create_backup_filename (const gchar* filename,
                               const gchar* backupdir);
VALA_EXTERN gboolean backup_and_write (Buffer* bp,
                           const gchar* filename);
VALA_EXTERN gboolean get_variable_bool (const gchar* name);
VALA_EXTERN const gchar* get_variable (const gchar* name);
VALA_EXTERN void waitkey (void);
VALA_EXTERN gboolean write_buffer (Buffer* bp,
                       gboolean needname,
                       gboolean confirm,
                       const gchar* name0,
                       const gchar* prompt);
VALA_EXTERN gchar* minibuf_read_filename (const gchar* fmt,
                              const gchar* value,
                              const gchar* file,
                              ...);
VALA_EXTERN gboolean funcall (const gchar* name,
                  glong* maybe_uniarg,
                  GeeQueue* args);
VALA_EXTERN void minibuf_write (const gchar* fmt,
                    ...);
VALA_EXTERN Keystroke getkeystroke (gint delay);
VALA_EXTERN void undo_set_unchanged (GList* l);
VALA_EXTERN gboolean save_buffer (Buffer* bp);
VALA_EXTERN void file_init (void);
static gboolean __lambda35_ (glong uniarg,
                      GeeQueue* args);
static gboolean ___lambda35__function (glong uniarg,
                                GeeQueue* args);
VALA_EXTERN LispFunc* lisp_func_new (const gchar* name,
                         Function func,
                         gboolean interactive,
                         const gchar* doc);
VALA_EXTERN LispFunc* lisp_func_construct (GType object_type,
                               const gchar* name,
                               Function func,
                               gboolean interactive,
                               const gchar* doc);
VALA_EXTERN gpointer lisp_func_ref (gpointer instance);
VALA_EXTERN void lisp_func_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_lisp_func (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_lisp_func (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_lisp_func (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_lisp_func (const GValue* value);
VALA_EXTERN GType lisp_func_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LispFunc, lisp_func_unref)
static gboolean __lambda36_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN LispFunc* lisp_func_find (const gchar* name);
static gboolean ___lambda36__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda37_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gboolean buffer_check_modified (Buffer* self);
VALA_EXTERN void buffer_kill (Buffer* self);
static gboolean ___lambda37__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda38_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gpointer completion_ref (gpointer instance);
VALA_EXTERN void completion_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_completion (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_completion (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_completion (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_completion (const GValue* value);
VALA_EXTERN GType completion_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Completion, completion_unref)
VALA_EXTERN Completion* buffer_make_buffer_completion (void);
VALA_EXTERN gpointer history_ref (gpointer instance);
VALA_EXTERN void history_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_history (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_history (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_history (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_history (const GValue* value);
VALA_EXTERN GType history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (History, history_unref)
VALA_EXTERN gchar* minibuf_read_completion (const gchar* fmt,
                                const gchar* val,
                                Completion* cp,
                                History* hp,
                                ...);
VALA_EXTERN Buffer* buffer_find (const gchar* name);
static gboolean ___lambda38__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda39_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gboolean buffer_warn_if_readonly (Buffer* self);
VALA_EXTERN void buffer_insert_buffer (Buffer* self,
                           Buffer* bp);
static gboolean ___lambda39__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda40_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gboolean buffer_insert_estr (Buffer* self,
                             ImmutableEstr* es);
static gboolean ___lambda40__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda41_ (glong uniarg,
                      GeeQueue* args);
static gboolean ___lambda41__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda42_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gboolean noarg (GeeQueue* args);
static gboolean ___lambda42__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda43_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gchar* buffer_get_filename_or_name (Buffer* self);
VALA_EXTERN Keystroke getkey (gint delay);
VALA_EXTERN void minibuf_clear (void);
static gboolean ___lambda43__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda44_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gboolean* minibuf_read_yesno (const gchar* fmt,
                              ...);
static gboolean _bool_equal (const gboolean * s1,
                      const gboolean * s2);
VALA_EXTERN void zile_exit (gint reason);
static gboolean ___lambda44__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda45_ (glong uniarg,
                      GeeQueue* args);
static gboolean ___lambda45__function (glong uniarg,
                                GeeQueue* args);

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 442 "file.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 469 "file.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 475 "file.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 481 "file.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 485 "file.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 493 "file.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 497 "file.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 509 "file.c"
}

gchar*
expand_path (const gchar* path)
{
	gboolean ok = FALSE;
	gchar* epath = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp87_ = NULL;
	gchar* _tmp89_;
	gchar* result;
#line 34 "src/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 35 "src/file.vala"
	ok = TRUE;
#line 36 "src/file.vala"
	_tmp0_ = g_strdup ("");
#line 36 "src/file.vala"
	epath = _tmp0_;
#line 38 "src/file.vala"
	if (string_get (path, (glong) 0) != '/') {
#line 38 "src/file.vala"
		_tmp1_ = string_get (path, (glong) 0) != '~';
#line 534 "file.c"
	} else {
#line 38 "src/file.vala"
		_tmp1_ = FALSE;
#line 538 "file.c"
	}
#line 38 "src/file.vala"
	if (_tmp1_) {
#line 542 "file.c"
		gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 39 "src/file.vala"
		_tmp2_ = g_get_current_dir ();
#line 39 "src/file.vala"
		_g_free0 (epath);
#line 39 "src/file.vala"
		epath = _tmp2_;
#line 40 "src/file.vala"
		_tmp4_ = epath;
#line 40 "src/file.vala"
		_tmp5_ = strlen (_tmp4_);
#line 40 "src/file.vala"
		_tmp6_ = _tmp5_;
#line 40 "src/file.vala"
		if (_tmp6_ == 0) {
#line 40 "src/file.vala"
			_tmp3_ = TRUE;
#line 564 "file.c"
		} else {
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 40 "src/file.vala"
			_tmp7_ = epath;
#line 40 "src/file.vala"
			_tmp8_ = epath;
#line 40 "src/file.vala"
			_tmp9_ = strlen (_tmp8_);
#line 40 "src/file.vala"
			_tmp10_ = _tmp9_;
#line 40 "src/file.vala"
			_tmp3_ = string_get (_tmp7_, (glong) (_tmp10_ - 1)) != '/';
#line 580 "file.c"
		}
#line 40 "src/file.vala"
		if (_tmp3_) {
#line 584 "file.c"
			const gchar* _tmp11_;
			gchar* _tmp12_;
#line 41 "src/file.vala"
			_tmp11_ = epath;
#line 41 "src/file.vala"
			_tmp12_ = g_strconcat (_tmp11_, "/", NULL);
#line 41 "src/file.vala"
			_g_free0 (epath);
#line 41 "src/file.vala"
			epath = _tmp12_;
#line 595 "file.c"
		}
	}
	{
		guint i = 0U;
#line 44 "src/file.vala"
		i = (guint) 0;
#line 602 "file.c"
		{
			gboolean _tmp13_ = FALSE;
#line 44 "src/file.vala"
			_tmp13_ = TRUE;
#line 44 "src/file.vala"
			while (TRUE) {
#line 609 "file.c"
				gint _tmp14_;
				gint _tmp15_;
#line 44 "src/file.vala"
				if (!_tmp13_) {
#line 614 "file.c"
				}
#line 44 "src/file.vala"
				_tmp13_ = FALSE;
#line 44 "src/file.vala"
				_tmp14_ = strlen (path);
#line 44 "src/file.vala"
				_tmp15_ = _tmp14_;
#line 44 "src/file.vala"
				if (!(i < ((guint) _tmp15_))) {
#line 44 "src/file.vala"
					break;
#line 626 "file.c"
				}
#line 45 "src/file.vala"
				if (string_get (path, (glong) i) == '/') {
#line 630 "file.c"
					guint _tmp16_;
					gboolean _tmp19_ = FALSE;
					const gchar* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 46 "src/file.vala"
					i = i + 1;
#line 46 "src/file.vala"
					_tmp16_ = i;
#line 46 "src/file.vala"
					if (string_get (path, (glong) _tmp16_) == '/') {
#line 642 "file.c"
						gchar* _tmp18_;
#line 48 "src/file.vala"
						while (TRUE) {
#line 646 "file.c"
							guint _tmp17_;
#line 48 "src/file.vala"
							if (!(string_get (path, (glong) i) == '/')) {
#line 48 "src/file.vala"
								break;
#line 652 "file.c"
							}
#line 49 "src/file.vala"
							_tmp17_ = i;
#line 49 "src/file.vala"
							i = _tmp17_ + 1;
#line 658 "file.c"
						}
#line 50 "src/file.vala"
						_tmp18_ = g_strdup ("");
#line 50 "src/file.vala"
						_g_free0 (epath);
#line 50 "src/file.vala"
						epath = _tmp18_;
#line 666 "file.c"
					}
#line 52 "src/file.vala"
					_tmp20_ = epath;
#line 52 "src/file.vala"
					_tmp21_ = strlen (_tmp20_);
#line 52 "src/file.vala"
					_tmp22_ = _tmp21_;
#line 52 "src/file.vala"
					if (_tmp22_ == 0) {
#line 52 "src/file.vala"
						_tmp19_ = TRUE;
#line 678 "file.c"
					} else {
						const gchar* _tmp23_;
						const gchar* _tmp24_;
						gint _tmp25_;
						gint _tmp26_;
#line 52 "src/file.vala"
						_tmp23_ = epath;
#line 52 "src/file.vala"
						_tmp24_ = epath;
#line 52 "src/file.vala"
						_tmp25_ = strlen (_tmp24_);
#line 52 "src/file.vala"
						_tmp26_ = _tmp25_;
#line 52 "src/file.vala"
						_tmp19_ = string_get (_tmp23_, (glong) (_tmp26_ - 1)) != '/';
#line 694 "file.c"
					}
#line 52 "src/file.vala"
					if (_tmp19_) {
#line 698 "file.c"
						const gchar* _tmp27_;
						gchar* _tmp28_;
#line 53 "src/file.vala"
						_tmp27_ = epath;
#line 53 "src/file.vala"
						_tmp28_ = g_strconcat (_tmp27_, "/", NULL);
#line 53 "src/file.vala"
						_g_free0 (epath);
#line 53 "src/file.vala"
						epath = _tmp28_;
#line 709 "file.c"
					}
				} else {
					gboolean _tmp29_ = FALSE;
#line 54 "src/file.vala"
					if (string_get (path, (glong) i) == '~') {
#line 715 "file.c"
						gboolean _tmp30_ = FALSE;
#line 54 "src/file.vala"
						if (i == ((guint) 0)) {
#line 54 "src/file.vala"
							_tmp30_ = TRUE;
#line 721 "file.c"
						} else {
#line 54 "src/file.vala"
							_tmp30_ = string_get (path, (glong) (i - 1)) == '/';
#line 725 "file.c"
						}
#line 54 "src/file.vala"
						_tmp29_ = _tmp30_;
#line 729 "file.c"
					} else {
#line 54 "src/file.vala"
						_tmp29_ = FALSE;
#line 733 "file.c"
					}
#line 54 "src/file.vala"
					if (_tmp29_) {
#line 737 "file.c"
						gchar* _tmp31_;
						guint _tmp32_;
#line 56 "src/file.vala"
						_tmp31_ = g_strdup ("");
#line 56 "src/file.vala"
						_g_free0 (epath);
#line 56 "src/file.vala"
						epath = _tmp31_;
#line 57 "src/file.vala"
						i = i + 1;
#line 57 "src/file.vala"
						_tmp32_ = i;
#line 59 "src/file.vala"
						if (string_get (path, (glong) i) == '/') {
#line 752 "file.c"
							struct passwd* pw = NULL;
							struct passwd* _tmp33_;
							struct passwd* _tmp34_;
							struct passwd* _tmp35_;
							const gchar* _tmp36_;
#line 61 "src/file.vala"
							_tmp33_ = getpwuid (getuid ());
#line 61 "src/file.vala"
							pw = _tmp33_;
#line 62 "src/file.vala"
							_tmp34_ = pw;
#line 62 "src/file.vala"
							if (_tmp34_ == NULL) {
#line 63 "src/file.vala"
								ok = FALSE;
#line 64 "src/file.vala"
								break;
#line 770 "file.c"
							}
#line 66 "src/file.vala"
							_tmp35_ = pw;
#line 66 "src/file.vala"
							_tmp36_ = _tmp35_->pw_dir;
#line 66 "src/file.vala"
							if (g_strcmp0 (_tmp36_, "/") != 0) {
#line 778 "file.c"
								const gchar* _tmp37_;
								struct passwd* _tmp38_;
								const gchar* _tmp39_;
								gchar* _tmp40_;
#line 67 "src/file.vala"
								_tmp37_ = epath;
#line 67 "src/file.vala"
								_tmp38_ = pw;
#line 67 "src/file.vala"
								_tmp39_ = _tmp38_->pw_dir;
#line 67 "src/file.vala"
								_tmp40_ = g_strconcat (_tmp37_, _tmp39_, NULL);
#line 67 "src/file.vala"
								_g_free0 (epath);
#line 67 "src/file.vala"
								epath = _tmp40_;
#line 795 "file.c"
							}
						} else {
							gchar* a = NULL;
							gchar* _tmp41_;
							struct passwd* pw = NULL;
							const gchar* _tmp48_;
							struct passwd* _tmp49_;
							struct passwd* _tmp50_;
							const gchar* _tmp51_;
							struct passwd* _tmp52_;
							const gchar* _tmp53_;
							gchar* _tmp54_;
#line 70 "src/file.vala"
							_tmp41_ = g_strdup ("");
#line 70 "src/file.vala"
							a = _tmp41_;
#line 71 "src/file.vala"
							while (TRUE) {
#line 814 "file.c"
								gboolean _tmp42_ = FALSE;
								const gchar* _tmp43_;
								guint _tmp44_;
								gchar* _tmp45_;
								gchar* _tmp46_;
								gchar* _tmp47_;
#line 71 "src/file.vala"
								if (string_get (path, (glong) i) != '\0') {
#line 71 "src/file.vala"
									_tmp42_ = string_get (path, (glong) i) != '/';
#line 825 "file.c"
								} else {
#line 71 "src/file.vala"
									_tmp42_ = FALSE;
#line 829 "file.c"
								}
#line 71 "src/file.vala"
								if (!_tmp42_) {
#line 71 "src/file.vala"
									break;
#line 835 "file.c"
								}
#line 72 "src/file.vala"
								_tmp43_ = a;
#line 72 "src/file.vala"
								_tmp44_ = i;
#line 72 "src/file.vala"
								i = _tmp44_ + 1;
#line 72 "src/file.vala"
								_tmp45_ = g_strdup_printf ("%c", string_get (path, (glong) _tmp44_));
#line 72 "src/file.vala"
								_tmp46_ = _tmp45_;
#line 72 "src/file.vala"
								_tmp47_ = g_strconcat (_tmp43_, _tmp46_, NULL);
#line 72 "src/file.vala"
								_g_free0 (a);
#line 72 "src/file.vala"
								a = _tmp47_;
#line 72 "src/file.vala"
								_g_free0 (_tmp46_);
#line 855 "file.c"
							}
#line 73 "src/file.vala"
							_tmp48_ = a;
#line 73 "src/file.vala"
							_tmp49_ = getpwnam (_tmp48_);
#line 73 "src/file.vala"
							pw = _tmp49_;
#line 74 "src/file.vala"
							_tmp50_ = pw;
#line 74 "src/file.vala"
							if (_tmp50_ == NULL) {
#line 75 "src/file.vala"
								ok = FALSE;
#line 76 "src/file.vala"
								_g_free0 (a);
#line 76 "src/file.vala"
								break;
#line 873 "file.c"
							}
#line 78 "src/file.vala"
							_tmp51_ = epath;
#line 78 "src/file.vala"
							_tmp52_ = pw;
#line 78 "src/file.vala"
							_tmp53_ = _tmp52_->pw_dir;
#line 78 "src/file.vala"
							_tmp54_ = g_strconcat (_tmp51_, _tmp53_, NULL);
#line 78 "src/file.vala"
							_g_free0 (epath);
#line 78 "src/file.vala"
							epath = _tmp54_;
#line 59 "src/file.vala"
							_g_free0 (a);
#line 889 "file.c"
						}
					} else {
						gboolean _tmp55_ = FALSE;
#line 80 "src/file.vala"
						if (string_get (path, (glong) i) == '.') {
#line 895 "file.c"
							gboolean _tmp56_ = FALSE;
#line 80 "src/file.vala"
							if (string_get (path, (glong) (i + 1)) == '/') {
#line 80 "src/file.vala"
								_tmp56_ = TRUE;
#line 901 "file.c"
							} else {
#line 80 "src/file.vala"
								_tmp56_ = string_get (path, (glong) (i + 1)) == '\0';
#line 905 "file.c"
							}
#line 80 "src/file.vala"
							_tmp55_ = _tmp56_;
#line 909 "file.c"
						} else {
#line 80 "src/file.vala"
							_tmp55_ = FALSE;
#line 913 "file.c"
						}
#line 80 "src/file.vala"
						if (_tmp55_) {
#line 917 "file.c"
							guint _tmp57_;
#line 82 "src/file.vala"
							i = i + 1;
#line 82 "src/file.vala"
							_tmp57_ = i;
#line 923 "file.c"
						} else {
							gboolean _tmp58_ = FALSE;
							gboolean _tmp59_ = FALSE;
#line 83 "src/file.vala"
							if (string_get (path, (glong) i) == '.') {
#line 83 "src/file.vala"
								_tmp59_ = string_get (path, (glong) (i + 1)) == '.';
#line 931 "file.c"
							} else {
#line 83 "src/file.vala"
								_tmp59_ = FALSE;
#line 935 "file.c"
							}
#line 83 "src/file.vala"
							if (_tmp59_) {
#line 939 "file.c"
								gboolean _tmp60_ = FALSE;
#line 83 "src/file.vala"
								if (string_get (path, (glong) (i + 2)) == '/') {
#line 83 "src/file.vala"
									_tmp60_ = TRUE;
#line 945 "file.c"
								} else {
#line 83 "src/file.vala"
									_tmp60_ = string_get (path, (glong) (i + 2)) == '\0';
#line 949 "file.c"
								}
#line 83 "src/file.vala"
								_tmp58_ = _tmp60_;
#line 953 "file.c"
							} else {
#line 83 "src/file.vala"
								_tmp58_ = FALSE;
#line 957 "file.c"
							}
#line 83 "src/file.vala"
							if (_tmp58_) {
#line 961 "file.c"
								gboolean _tmp61_ = FALSE;
								const gchar* _tmp62_;
								gint _tmp63_;
								gint _tmp64_;
#line 85 "src/file.vala"
								_tmp62_ = epath;
#line 85 "src/file.vala"
								_tmp63_ = strlen (_tmp62_);
#line 85 "src/file.vala"
								_tmp64_ = _tmp63_;
#line 85 "src/file.vala"
								if (_tmp64_ >= 1) {
#line 974 "file.c"
									const gchar* _tmp65_;
									const gchar* _tmp66_;
									gint _tmp67_;
									gint _tmp68_;
#line 85 "src/file.vala"
									_tmp65_ = epath;
#line 85 "src/file.vala"
									_tmp66_ = epath;
#line 85 "src/file.vala"
									_tmp67_ = strlen (_tmp66_);
#line 85 "src/file.vala"
									_tmp68_ = _tmp67_;
#line 85 "src/file.vala"
									_tmp61_ = string_get (_tmp65_, (glong) (_tmp68_ - 1)) == '/';
#line 989 "file.c"
								} else {
#line 85 "src/file.vala"
									_tmp61_ = FALSE;
#line 993 "file.c"
								}
#line 85 "src/file.vala"
								if (_tmp61_) {
#line 997 "file.c"
									const gchar* _tmp69_;
									gchar* _tmp70_;
#line 86 "src/file.vala"
									_tmp69_ = epath;
#line 86 "src/file.vala"
									_tmp70_ = string_slice (_tmp69_, (glong) 0, (glong) -1);
#line 86 "src/file.vala"
									_g_free0 (epath);
#line 86 "src/file.vala"
									epath = _tmp70_;
#line 1008 "file.c"
								}
#line 87 "src/file.vala"
								while (TRUE) {
#line 1012 "file.c"
									gboolean _tmp71_ = FALSE;
									const gchar* _tmp72_;
									const gchar* _tmp73_;
									gint _tmp74_;
									gint _tmp75_;
									const gchar* _tmp79_;
									gchar* _tmp80_;
#line 87 "src/file.vala"
									_tmp72_ = epath;
#line 87 "src/file.vala"
									_tmp73_ = epath;
#line 87 "src/file.vala"
									_tmp74_ = strlen (_tmp73_);
#line 87 "src/file.vala"
									_tmp75_ = _tmp74_;
#line 87 "src/file.vala"
									if (string_get (_tmp72_, (glong) (_tmp75_ - 1)) != '/') {
#line 1030 "file.c"
										const gchar* _tmp76_;
										gint _tmp77_;
										gint _tmp78_;
#line 87 "src/file.vala"
										_tmp76_ = epath;
#line 87 "src/file.vala"
										_tmp77_ = strlen (_tmp76_);
#line 87 "src/file.vala"
										_tmp78_ = _tmp77_;
#line 87 "src/file.vala"
										_tmp71_ = _tmp78_ >= 1;
#line 1042 "file.c"
									} else {
#line 87 "src/file.vala"
										_tmp71_ = FALSE;
#line 1046 "file.c"
									}
#line 87 "src/file.vala"
									if (!_tmp71_) {
#line 87 "src/file.vala"
										break;
#line 1052 "file.c"
									}
#line 88 "src/file.vala"
									_tmp79_ = epath;
#line 88 "src/file.vala"
									_tmp80_ = string_slice (_tmp79_, (glong) 0, (glong) -1);
#line 88 "src/file.vala"
									_g_free0 (epath);
#line 88 "src/file.vala"
									epath = _tmp80_;
#line 1062 "file.c"
								}
#line 89 "src/file.vala"
								i += (guint) 2;
#line 1066 "file.c"
							}
						}
					}
				}
#line 92 "src/file.vala"
				if (string_get (path, (glong) i) != '~') {
#line 93 "src/file.vala"
					while (TRUE) {
#line 1075 "file.c"
						gboolean _tmp81_ = FALSE;
						const gchar* _tmp82_;
						guint _tmp83_;
						gchar* _tmp84_;
						gchar* _tmp85_;
						gchar* _tmp86_;
#line 93 "src/file.vala"
						if (string_get (path, (glong) i) != '\0') {
#line 93 "src/file.vala"
							_tmp81_ = string_get (path, (glong) i) != '/';
#line 1086 "file.c"
						} else {
#line 93 "src/file.vala"
							_tmp81_ = FALSE;
#line 1090 "file.c"
						}
#line 93 "src/file.vala"
						if (!_tmp81_) {
#line 93 "src/file.vala"
							break;
#line 1096 "file.c"
						}
#line 94 "src/file.vala"
						_tmp82_ = epath;
#line 94 "src/file.vala"
						_tmp83_ = i;
#line 94 "src/file.vala"
						i = _tmp83_ + 1;
#line 94 "src/file.vala"
						_tmp84_ = g_strdup_printf ("%c", string_get (path, (glong) _tmp83_));
#line 94 "src/file.vala"
						_tmp85_ = _tmp84_;
#line 94 "src/file.vala"
						_tmp86_ = g_strconcat (_tmp82_, _tmp85_, NULL);
#line 94 "src/file.vala"
						_g_free0 (epath);
#line 94 "src/file.vala"
						epath = _tmp86_;
#line 94 "src/file.vala"
						_g_free0 (_tmp85_);
#line 1116 "file.c"
					}
				}
			}
		}
	}
#line 97 "src/file.vala"
	if (ok) {
#line 1124 "file.c"
		const gchar* _tmp88_;
#line 97 "src/file.vala"
		_tmp88_ = epath;
#line 97 "src/file.vala"
		_tmp87_ = _tmp88_;
#line 1130 "file.c"
	} else {
#line 97 "src/file.vala"
		_tmp87_ = NULL;
#line 1134 "file.c"
	}
#line 97 "src/file.vala"
	_tmp89_ = g_strdup (_tmp87_);
#line 97 "src/file.vala"
	result = _tmp89_;
#line 97 "src/file.vala"
	_g_free0 (epath);
#line 97 "src/file.vala"
	return result;
#line 1144 "file.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 1167 "file.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 1176 "file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1195 "file.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1199 "file.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1205 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1215 "file.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1223 "file.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1227 "file.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1233 "file.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1243 "file.c"
}

gchar*
compact_path (const gchar* in_path)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	struct passwd* pw = NULL;
	struct passwd* _tmp1_;
	struct passwd* _tmp2_;
	gchar* result;
#line 104 "src/file.vala"
	g_return_val_if_fail (in_path != NULL, NULL);
#line 105 "src/file.vala"
	_tmp0_ = g_strdup (in_path);
#line 105 "src/file.vala"
	path = _tmp0_;
#line 106 "src/file.vala"
	_tmp1_ = getpwuid (getuid ());
#line 106 "src/file.vala"
	pw = _tmp1_;
#line 108 "src/file.vala"
	_tmp2_ = pw;
#line 108 "src/file.vala"
	if (_tmp2_ != NULL) {
#line 1269 "file.c"
		guint homelen = 0U;
		struct passwd* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		const gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 110 "src/file.vala"
		_tmp3_ = pw;
#line 110 "src/file.vala"
		_tmp4_ = _tmp3_->pw_dir;
#line 110 "src/file.vala"
		_tmp5_ = strlen (_tmp4_);
#line 110 "src/file.vala"
		_tmp6_ = _tmp5_;
#line 110 "src/file.vala"
		homelen = (guint) _tmp6_;
#line 111 "src/file.vala"
		if (homelen > ((guint) 0)) {
#line 1293 "file.c"
			struct passwd* _tmp8_;
			const gchar* _tmp9_;
#line 111 "src/file.vala"
			_tmp8_ = pw;
#line 111 "src/file.vala"
			_tmp9_ = _tmp8_->pw_dir;
#line 111 "src/file.vala"
			_tmp7_ = string_get (_tmp9_, (glong) (homelen - 1)) == '/';
#line 1302 "file.c"
		} else {
#line 111 "src/file.vala"
			_tmp7_ = FALSE;
#line 1306 "file.c"
		}
#line 111 "src/file.vala"
		if (_tmp7_) {
#line 1310 "file.c"
			guint _tmp10_;
#line 112 "src/file.vala"
			_tmp10_ = homelen;
#line 112 "src/file.vala"
			homelen = _tmp10_ - 1;
#line 1316 "file.c"
		}
#line 114 "src/file.vala"
		_tmp13_ = path;
#line 114 "src/file.vala"
		_tmp14_ = strlen (_tmp13_);
#line 114 "src/file.vala"
		_tmp15_ = _tmp14_;
#line 114 "src/file.vala"
		if (((guint) _tmp15_) > homelen) {
#line 1326 "file.c"
			struct passwd* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 115 "src/file.vala"
			_tmp16_ = pw;
#line 115 "src/file.vala"
			_tmp17_ = _tmp16_->pw_dir;
#line 115 "src/file.vala"
			_tmp18_ = path;
#line 115 "src/file.vala"
			_tmp12_ = strncmp (_tmp17_, _tmp18_, (gsize) homelen) == 0;
#line 1338 "file.c"
		} else {
#line 114 "src/file.vala"
			_tmp12_ = FALSE;
#line 1342 "file.c"
		}
#line 114 "src/file.vala"
		if (_tmp12_) {
#line 1346 "file.c"
			const gchar* _tmp19_;
#line 116 "src/file.vala"
			_tmp19_ = path;
#line 116 "src/file.vala"
			_tmp11_ = string_get (_tmp19_, (glong) homelen) == '/';
#line 1352 "file.c"
		} else {
#line 114 "src/file.vala"
			_tmp11_ = FALSE;
#line 1356 "file.c"
		}
#line 114 "src/file.vala"
		if (_tmp11_) {
#line 1360 "file.c"
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 117 "src/file.vala"
			_tmp20_ = path;
#line 117 "src/file.vala"
			_tmp21_ = string_substring (_tmp20_, (glong) (homelen + 1), (glong) -1);
#line 117 "src/file.vala"
			_tmp22_ = _tmp21_;
#line 117 "src/file.vala"
			_tmp23_ = g_strconcat ("~/", _tmp22_, NULL);
#line 117 "src/file.vala"
			_g_free0 (path);
#line 117 "src/file.vala"
			path = _tmp23_;
#line 117 "src/file.vala"
			_g_free0 (_tmp22_);
#line 1379 "file.c"
		}
	}
#line 120 "src/file.vala"
	result = path;
#line 120 "src/file.vala"
	return result;
#line 1386 "file.c"
}

gboolean
check_writable (const gchar* filename)
{
	gboolean result;
#line 124 "src/file.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 125 "src/file.vala"
	result = euidaccess (filename, W_OK) >= 0;
#line 125 "src/file.vala"
	return result;
#line 1399 "file.c"
}

static gpointer
_buffer_ref0 (gpointer self)
{
#line 130 "src/file.vala"
	return self ? buffer_ref (self) : NULL;
#line 1407 "file.c"
}

gboolean
find_file (const gchar* filename)
{
	Buffer* bp = NULL;
	Buffer* _tmp9_;
	Buffer* _tmp27_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 128 "src/file.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 1420 "file.c"
	{
		Buffer* _tmp0_;
		Buffer* _tmp1_;
		gboolean _tmp2_ = FALSE;
#line 130 "src/file.vala"
		_tmp0_ = head_bp;
#line 130 "src/file.vala"
		_tmp1_ = _buffer_ref0 (_tmp0_);
#line 130 "src/file.vala"
		_buffer_unref0 (bp);
#line 130 "src/file.vala"
		bp = _tmp1_;
#line 130 "src/file.vala"
		_tmp2_ = TRUE;
#line 130 "src/file.vala"
		while (TRUE) {
#line 1437 "file.c"
			Buffer* _tmp6_;
			Buffer* _tmp7_;
			const gchar* _tmp8_;
#line 130 "src/file.vala"
			if (!_tmp2_) {
#line 1443 "file.c"
				Buffer* _tmp3_;
				Buffer* _tmp4_;
				Buffer* _tmp5_;
#line 130 "src/file.vala"
				_tmp3_ = bp;
#line 130 "src/file.vala"
				_tmp4_ = _tmp3_->next;
#line 130 "src/file.vala"
				_tmp5_ = _buffer_ref0 (_tmp4_);
#line 130 "src/file.vala"
				_buffer_unref0 (bp);
#line 130 "src/file.vala"
				bp = _tmp5_;
#line 1457 "file.c"
			}
#line 130 "src/file.vala"
			_tmp2_ = FALSE;
#line 130 "src/file.vala"
			_tmp6_ = bp;
#line 130 "src/file.vala"
			if (!(_tmp6_ != NULL)) {
#line 130 "src/file.vala"
				break;
#line 1467 "file.c"
			}
#line 131 "src/file.vala"
			_tmp7_ = bp;
#line 131 "src/file.vala"
			_tmp8_ = _tmp7_->filename;
#line 131 "src/file.vala"
			if (g_strcmp0 (_tmp8_, filename) == 0) {
#line 132 "src/file.vala"
				break;
#line 1477 "file.c"
			}
		}
	}
#line 134 "src/file.vala"
	_tmp9_ = bp;
#line 134 "src/file.vala"
	if (_tmp9_ == NULL) {
#line 1485 "file.c"
		gboolean _tmp10_ = FALSE;
#line 135 "src/file.vala"
		if (g_file_test (filename, G_FILE_TEST_EXISTS)) {
#line 136 "src/file.vala"
			_tmp10_ = !g_file_test (filename, G_FILE_TEST_IS_REGULAR);
#line 1491 "file.c"
		} else {
#line 135 "src/file.vala"
			_tmp10_ = FALSE;
#line 1495 "file.c"
		}
#line 135 "src/file.vala"
		if (_tmp10_) {
#line 137 "src/file.vala"
			minibuf_error ("File exists but could not be read", NULL);
#line 138 "src/file.vala"
			result = FALSE;
#line 138 "src/file.vala"
			_buffer_unref0 (bp);
#line 138 "src/file.vala"
			return result;
#line 1507 "file.c"
		} else {
			Estr* es = NULL;
			Buffer* _tmp21_;
			Buffer* _tmp22_;
			gchar* _tmp23_;
			Buffer* _tmp24_;
			Buffer* _tmp25_;
			Buffer* _tmp26_;
			{
				Estr* _tmp11_ = NULL;
				Estr* _tmp12_;
				Estr* _tmp13_;
				Estr* _tmp14_;
				Buffer* _tmp15_;
				Buffer* _tmp16_;
#line 142 "src/file.vala"
				_tmp12_ = estr_from_file (filename, &_inner_error0_);
#line 142 "src/file.vala"
				_tmp11_ = _tmp12_;
#line 142 "src/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1529 "file.c"
					goto __catch0_g_error;
				}
#line 142 "src/file.vala"
				_tmp13_ = _tmp11_;
#line 142 "src/file.vala"
				_tmp11_ = NULL;
#line 142 "src/file.vala"
				_immutable_estr_unref0 (es);
#line 142 "src/file.vala"
				es = _tmp13_;
#line 143 "src/file.vala"
				_tmp14_ = es;
#line 143 "src/file.vala"
				_tmp15_ = buffer_new (_tmp14_);
#line 143 "src/file.vala"
				_buffer_unref0 (bp);
#line 143 "src/file.vala"
				bp = _tmp15_;
#line 144 "src/file.vala"
				_tmp16_ = bp;
#line 144 "src/file.vala"
				_tmp16_->readonly = !check_writable (filename);
#line 141 "src/file.vala"
				_immutable_estr_unref0 (_tmp11_);
#line 1554 "file.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				Estr* _tmp17_;
				Estr* _tmp18_;
				Buffer* _tmp19_;
#line 141 "src/file.vala"
				g_clear_error (&_inner_error0_);
#line 146 "src/file.vala"
				_tmp17_ = estr_of_empty (IMMUTABLE_ESTR_eol_lf);
#line 146 "src/file.vala"
				_tmp18_ = _tmp17_;
#line 146 "src/file.vala"
				_tmp19_ = buffer_new (_tmp18_);
#line 146 "src/file.vala"
				_buffer_unref0 (bp);
#line 146 "src/file.vala"
				bp = _tmp19_;
#line 146 "src/file.vala"
				_immutable_estr_unref0 (_tmp18_);
#line 1576 "file.c"
			}
			__finally0:
#line 141 "src/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1581 "file.c"
				gboolean _tmp20_ = FALSE;
#line 141 "src/file.vala"
				_immutable_estr_unref0 (es);
#line 141 "src/file.vala"
				_buffer_unref0 (bp);
#line 141 "src/file.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "src/file.vala"
				g_clear_error (&_inner_error0_);
#line 141 "src/file.vala"
				return _tmp20_;
#line 1593 "file.c"
			}
#line 148 "src/file.vala"
			_tmp21_ = bp;
#line 148 "src/file.vala"
			buffer_set_names (_tmp21_, filename);
#line 149 "src/file.vala"
			_tmp22_ = bp;
#line 149 "src/file.vala"
			_tmp23_ = g_path_get_dirname (filename);
#line 149 "src/file.vala"
			_g_free0 (_tmp22_->dir);
#line 149 "src/file.vala"
			_tmp22_->dir = _tmp23_;
#line 152 "src/file.vala"
			_tmp24_ = bp;
#line 152 "src/file.vala"
			_tmp24_->next_undop = NULL;
#line 153 "src/file.vala"
			_tmp25_ = bp;
#line 153 "src/file.vala"
			_tmp25_->last_undop = NULL;
#line 154 "src/file.vala"
			_tmp26_ = bp;
#line 154 "src/file.vala"
			_tmp26_->modified = FALSE;
#line 135 "src/file.vala"
			_immutable_estr_unref0 (es);
#line 1621 "file.c"
		}
	}
#line 158 "src/file.vala"
	_tmp27_ = bp;
#line 158 "src/file.vala"
	buffer_switch_to (_tmp27_);
#line 159 "src/file.vala"
	thisflag = thisflag | FLAGS_NEED_RESYNC;
#line 160 "src/file.vala"
	result = TRUE;
#line 160 "src/file.vala"
	_buffer_unref0 (bp);
#line 160 "src/file.vala"
	return result;
#line 1636 "file.c"
}

gint
write_all (gint fd,
           gchar* data,
           gsize length)
{
	gint result;
	{
		gsize tot_written = 0UL;
#line 165 "src/file.vala"
		tot_written = (gsize) 0;
#line 1649 "file.c"
		{
			gboolean _tmp0_ = FALSE;
#line 165 "src/file.vala"
			_tmp0_ = TRUE;
#line 165 "src/file.vala"
			while (TRUE) {
#line 1656 "file.c"
				gssize written = 0L;
#line 165 "src/file.vala"
				if (!_tmp0_) {
#line 1660 "file.c"
				}
#line 165 "src/file.vala"
				_tmp0_ = FALSE;
#line 165 "src/file.vala"
				if (!(tot_written < length)) {
#line 165 "src/file.vala"
					break;
#line 1668 "file.c"
				}
#line 166 "src/file.vala"
				written = write (fd, data, length);
#line 167 "src/file.vala"
				if (written < ((gssize) 0)) {
#line 168 "src/file.vala"
					result = (gint) written;
#line 168 "src/file.vala"
					return result;
#line 1678 "file.c"
				}
#line 169 "src/file.vala"
				if (written == ((gssize) 0)) {
#line 170 "src/file.vala"
					result = 1;
#line 170 "src/file.vala"
					return result;
#line 1686 "file.c"
				}
#line 171 "src/file.vala"
				tot_written += (gsize) written;
#line 1690 "file.c"
			}
		}
	}
#line 173 "src/file.vala"
	result = 0;
#line 173 "src/file.vala"
	return result;
#line 1698 "file.c"
}

gint
write_to_disk (Buffer* bp,
               const gchar* filename,
               mode_t mode)
{
	gint fd = 0;
	ImmutableEstr* es = NULL;
	ImmutableEstr* _tmp0_;
	gint ret = 0;
	ImmutableEstr* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ImmutableEstr* _tmp4_;
	gsize _tmp5_;
	gsize _tmp6_;
	gboolean _tmp14_ = FALSE;
	gint result;
#line 179 "src/file.vala"
	g_return_val_if_fail (bp != NULL, 0);
#line 179 "src/file.vala"
	g_return_val_if_fail (filename != NULL, 0);
#line 180 "src/file.vala"
	fd = creat (filename, mode);
#line 181 "src/file.vala"
	if (fd < 0) {
#line 182 "src/file.vala"
		result = -1;
#line 182 "src/file.vala"
		return result;
#line 1730 "file.c"
	}
#line 184 "src/file.vala"
	_tmp0_ = buffer_pre_point (bp);
#line 184 "src/file.vala"
	es = _tmp0_;
#line 185 "src/file.vala"
	_tmp1_ = es;
#line 185 "src/file.vala"
	_tmp2_ = immutable_estr_get_text (_tmp1_);
#line 185 "src/file.vala"
	_tmp3_ = _tmp2_;
#line 185 "src/file.vala"
	_tmp4_ = es;
#line 185 "src/file.vala"
	_tmp5_ = immutable_estr_get_length (_tmp4_);
#line 185 "src/file.vala"
	_tmp6_ = _tmp5_;
#line 185 "src/file.vala"
	ret = write_all (fd, _tmp3_, _tmp6_);
#line 186 "src/file.vala"
	if (ret == 0) {
#line 1752 "file.c"
		ImmutableEstr* _tmp7_;
		ImmutableEstr* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		ImmutableEstr* _tmp11_;
		gsize _tmp12_;
		gsize _tmp13_;
#line 187 "src/file.vala"
		_tmp7_ = buffer_post_point (bp);
#line 187 "src/file.vala"
		_immutable_estr_unref0 (es);
#line 187 "src/file.vala"
		es = _tmp7_;
#line 188 "src/file.vala"
		_tmp8_ = es;
#line 188 "src/file.vala"
		_tmp9_ = immutable_estr_get_text (_tmp8_);
#line 188 "src/file.vala"
		_tmp10_ = _tmp9_;
#line 188 "src/file.vala"
		_tmp11_ = es;
#line 188 "src/file.vala"
		_tmp12_ = immutable_estr_get_length (_tmp11_);
#line 188 "src/file.vala"
		_tmp13_ = _tmp12_;
#line 188 "src/file.vala"
		ret = write_all (fd, _tmp10_, _tmp13_);
#line 1780 "file.c"
	}
#line 191 "src/file.vala"
	if (close (fd) < 0) {
#line 191 "src/file.vala"
		_tmp14_ = ret == 0;
#line 1786 "file.c"
	} else {
#line 191 "src/file.vala"
		_tmp14_ = FALSE;
#line 1790 "file.c"
	}
#line 191 "src/file.vala"
	if (_tmp14_) {
#line 192 "src/file.vala"
		ret = -1;
#line 1796 "file.c"
	}
#line 194 "src/file.vala"
	result = ret;
#line 194 "src/file.vala"
	_immutable_estr_unref0 (es);
#line 194 "src/file.vala"
	return result;
#line 1804 "file.c"
}

gchar*
create_backup_filename (const gchar* filename,
                        const gchar* backupdir)
{
	gchar* res = NULL;
	const gchar* _tmp19_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 200 "src/file.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 201 "src/file.vala"
	res = NULL;
#line 204 "src/file.vala"
	if (backupdir != NULL) {
#line 1822 "file.c"
		gchar* buf = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 205 "src/file.vala"
		_tmp0_ = g_strdup (backupdir);
#line 205 "src/file.vala"
		buf = _tmp0_;
#line 206 "src/file.vala"
		_tmp1_ = buf;
#line 206 "src/file.vala"
		_tmp2_ = buf;
#line 206 "src/file.vala"
		_tmp3_ = strlen (_tmp2_);
#line 206 "src/file.vala"
		_tmp4_ = _tmp3_;
#line 206 "src/file.vala"
		if (string_get (_tmp1_, (glong) (_tmp4_ - 1)) != '/') {
#line 1845 "file.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 207 "src/file.vala"
			_tmp5_ = buf;
#line 207 "src/file.vala"
			_tmp6_ = g_strconcat (_tmp5_, "/", NULL);
#line 207 "src/file.vala"
			_g_free0 (buf);
#line 207 "src/file.vala"
			buf = _tmp6_;
#line 1856 "file.c"
		}
		{
			guint i = 0U;
#line 208 "src/file.vala"
			i = (guint) 0;
#line 1862 "file.c"
			{
				gboolean _tmp7_ = FALSE;
#line 208 "src/file.vala"
				_tmp7_ = TRUE;
#line 208 "src/file.vala"
				while (TRUE) {
#line 1869 "file.c"
					gint _tmp9_;
					gint _tmp10_;
#line 208 "src/file.vala"
					if (!_tmp7_) {
#line 1874 "file.c"
						guint _tmp8_;
#line 208 "src/file.vala"
						_tmp8_ = i;
#line 208 "src/file.vala"
						i = _tmp8_ + 1;
#line 1880 "file.c"
					}
#line 208 "src/file.vala"
					_tmp7_ = FALSE;
#line 208 "src/file.vala"
					_tmp9_ = strlen (filename);
#line 208 "src/file.vala"
					_tmp10_ = _tmp9_;
#line 208 "src/file.vala"
					if (!(i < ((guint) _tmp10_))) {
#line 208 "src/file.vala"
						break;
#line 1892 "file.c"
					}
#line 209 "src/file.vala"
					if (string_get (filename, (glong) i) == '/') {
#line 1896 "file.c"
						const gchar* _tmp11_;
						gchar* _tmp12_;
#line 210 "src/file.vala"
						_tmp11_ = buf;
#line 210 "src/file.vala"
						_tmp12_ = g_strconcat (_tmp11_, "!", NULL);
#line 210 "src/file.vala"
						_g_free0 (buf);
#line 210 "src/file.vala"
						buf = _tmp12_;
#line 1907 "file.c"
					} else {
						const gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
#line 212 "src/file.vala"
						_tmp13_ = buf;
#line 212 "src/file.vala"
						_tmp14_ = g_strdup_printf ("%c", string_get (filename, (glong) i));
#line 212 "src/file.vala"
						_tmp15_ = _tmp14_;
#line 212 "src/file.vala"
						_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
#line 212 "src/file.vala"
						_g_free0 (buf);
#line 212 "src/file.vala"
						buf = _tmp16_;
#line 212 "src/file.vala"
						_g_free0 (_tmp15_);
#line 1927 "file.c"
					}
				}
			}
		}
#line 214 "src/file.vala"
		_tmp17_ = buf;
#line 214 "src/file.vala"
		_tmp18_ = expand_path (_tmp17_);
#line 214 "src/file.vala"
		_g_free0 (res);
#line 214 "src/file.vala"
		res = _tmp18_;
#line 204 "src/file.vala"
		_g_free0 (buf);
#line 1942 "file.c"
	}
#line 217 "src/file.vala"
	_tmp19_ = res;
#line 217 "src/file.vala"
	if (_tmp19_ == NULL) {
#line 1948 "file.c"
		gchar* _tmp20_;
#line 218 "src/file.vala"
		_tmp20_ = g_strdup (filename);
#line 218 "src/file.vala"
		_g_free0 (res);
#line 218 "src/file.vala"
		res = _tmp20_;
#line 1956 "file.c"
	}
#line 220 "src/file.vala"
	_tmp21_ = res;
#line 220 "src/file.vala"
	_tmp22_ = g_strconcat (_tmp21_, "~", NULL);
#line 220 "src/file.vala"
	result = _tmp22_;
#line 220 "src/file.vala"
	_g_free0 (res);
#line 220 "src/file.vala"
	return result;
#line 1968 "file.c"
}

gboolean
backup_and_write (Buffer* bp,
                  const gchar* filename)
{
	gint fd = 0;
	gboolean backup = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint ret = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 227 "src/file.vala"
	g_return_val_if_fail (bp != NULL, FALSE);
#line 227 "src/file.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 229 "src/file.vala"
	fd = 0;
#line 230 "src/file.vala"
	backup = get_variable_bool ("make-backup-files");
#line 231 "src/file.vala"
	if (bp->backup) {
#line 231 "src/file.vala"
		_tmp1_ = backup;
#line 1994 "file.c"
	} else {
#line 231 "src/file.vala"
		_tmp1_ = FALSE;
#line 1998 "file.c"
	}
#line 231 "src/file.vala"
	if (_tmp1_) {
#line 231 "src/file.vala"
		fd = open (filename, O_RDWR, (mode_t) 0);
#line 231 "src/file.vala"
		_tmp0_ = fd != -1;
#line 2006 "file.c"
	} else {
#line 231 "src/file.vala"
		_tmp0_ = FALSE;
#line 2010 "file.c"
	}
#line 231 "src/file.vala"
	if (_tmp0_) {
#line 2014 "file.c"
		const gchar* _tmp2_ = NULL;
		gchar* backupdir = NULL;
		gchar* _tmp4_;
		gchar* bfilename = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 232 "src/file.vala"
		close (fd);
#line 234 "src/file.vala"
		if (get_variable_bool ("backup-directory")) {
#line 2026 "file.c"
			const gchar* _tmp3_;
#line 235 "src/file.vala"
			_tmp3_ = get_variable ("backup-directory");
#line 235 "src/file.vala"
			_tmp2_ = _tmp3_;
#line 2032 "file.c"
		} else {
#line 235 "src/file.vala"
			_tmp2_ = NULL;
#line 2036 "file.c"
		}
#line 234 "src/file.vala"
		_tmp4_ = g_strdup (_tmp2_);
#line 234 "src/file.vala"
		backupdir = _tmp4_;
#line 236 "src/file.vala"
		_tmp5_ = backupdir;
#line 236 "src/file.vala"
		_tmp6_ = create_backup_filename (filename, _tmp5_);
#line 236 "src/file.vala"
		bfilename = _tmp6_;
#line 237 "src/file.vala"
		_tmp7_ = bfilename;
#line 237 "src/file.vala"
		if (_tmp7_ != NULL) {
#line 2052 "file.c"
			{
				GFile* _tmp8_;
				GFile* _tmp9_;
				const gchar* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
#line 239 "src/file.vala"
				_tmp8_ = g_file_new_for_path (filename);
#line 239 "src/file.vala"
				_tmp9_ = _tmp8_;
#line 239 "src/file.vala"
				_tmp10_ = bfilename;
#line 239 "src/file.vala"
				_tmp11_ = g_file_new_for_path (_tmp10_);
#line 239 "src/file.vala"
				_tmp12_ = _tmp11_;
#line 239 "src/file.vala"
				g_file_copy (_tmp9_, _tmp12_, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
#line 239 "src/file.vala"
				_g_object_unref0 (_tmp12_);
#line 239 "src/file.vala"
				_g_object_unref0 (_tmp9_);
#line 239 "src/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2077 "file.c"
					goto __catch0_g_error;
				}
#line 241 "src/file.vala"
				bp->backup = TRUE;
#line 2082 "file.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp13_;
				const gchar* _tmp14_;
#line 238 "src/file.vala"
				e = _inner_error0_;
#line 238 "src/file.vala"
				_inner_error0_ = NULL;
#line 243 "src/file.vala"
				_tmp13_ = e;
#line 243 "src/file.vala"
				_tmp14_ = _tmp13_->message;
#line 243 "src/file.vala"
				minibuf_error ("Cannot make backup file: %s", _tmp14_, NULL);
#line 244 "src/file.vala"
				waitkey ();
#line 238 "src/file.vala"
				_g_error_free0 (e);
#line 2104 "file.c"
			}
			__finally0:
#line 238 "src/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2109 "file.c"
				gboolean _tmp15_ = FALSE;
#line 238 "src/file.vala"
				_g_free0 (bfilename);
#line 238 "src/file.vala"
				_g_free0 (backupdir);
#line 238 "src/file.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 238 "src/file.vala"
				g_clear_error (&_inner_error0_);
#line 238 "src/file.vala"
				return _tmp15_;
#line 2121 "file.c"
			}
		}
#line 231 "src/file.vala"
		_g_free0 (bfilename);
#line 231 "src/file.vala"
		_g_free0 (backupdir);
#line 2128 "file.c"
	}
#line 248 "src/file.vala"
	ret = write_to_disk (bp, filename, ((((S_IRUSR | S_IWUSR) | S_IRGRP) | S_IWGRP) | S_IROTH) | S_IWOTH);
#line 249 "src/file.vala"
	if (ret == 0) {
#line 250 "src/file.vala"
		result = TRUE;
#line 250 "src/file.vala"
		return result;
#line 2138 "file.c"
	}
#line 252 "src/file.vala"
	if (ret == -1) {
#line 2142 "file.c"
		const gchar* _tmp16_;
#line 253 "src/file.vala"
		_tmp16_ = strerror (errno);
#line 253 "src/file.vala"
		minibuf_error ("Error writing `%s': %s", filename, _tmp16_, NULL);
#line 2148 "file.c"
	} else {
#line 255 "src/file.vala"
		minibuf_error ("Error writing `%s'", filename, NULL);
#line 2152 "file.c"
	}
#line 256 "src/file.vala"
	result = FALSE;
#line 256 "src/file.vala"
	return result;
#line 2158 "file.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 2171 "file.c"
}

gboolean
write_buffer (Buffer* bp,
              gboolean needname,
              gboolean confirm,
              const gchar* name0,
              const gchar* prompt)
{
	gint ans = 0;
	gboolean ok = FALSE;
	gchar* name = NULL;
	gboolean _tmp6_ = FALSE;
	gboolean result;
#line 259 "src/file.vala"
	g_return_val_if_fail (bp != NULL, FALSE);
#line 259 "src/file.vala"
	g_return_val_if_fail (prompt != NULL, FALSE);
#line 260 "src/file.vala"
	ans = 1;
#line 261 "src/file.vala"
	ok = TRUE;
#line 262 "src/file.vala"
	name = NULL;
#line 264 "src/file.vala"
	if (!needname) {
#line 2198 "file.c"
		gchar* _tmp0_;
#line 265 "src/file.vala"
		_vala_assert (name0 != NULL, "name0 != null");
#line 266 "src/file.vala"
		_tmp0_ = g_strdup (name0);
#line 266 "src/file.vala"
		_g_free0 (name);
#line 266 "src/file.vala"
		name = _tmp0_;
#line 2208 "file.c"
	} else {
		gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 268 "src/file.vala"
		_tmp1_ = minibuf_read_filename ("%s", "", NULL, prompt, NULL);
#line 268 "src/file.vala"
		_g_free0 (name);
#line 268 "src/file.vala"
		name = _tmp1_;
#line 269 "src/file.vala"
		_tmp2_ = name;
#line 269 "src/file.vala"
		if (_tmp2_ == NULL) {
#line 270 "src/file.vala"
			result = funcall ("keyboard-quit", NULL, NULL);
#line 270 "src/file.vala"
			_g_free0 (name);
#line 270 "src/file.vala"
			return result;
#line 2231 "file.c"
		}
#line 271 "src/file.vala"
		_tmp3_ = name;
#line 271 "src/file.vala"
		_tmp4_ = strlen (_tmp3_);
#line 271 "src/file.vala"
		_tmp5_ = _tmp4_;
#line 271 "src/file.vala"
		if (_tmp5_ == 0) {
#line 272 "src/file.vala"
			result = FALSE;
#line 272 "src/file.vala"
			_g_free0 (name);
#line 272 "src/file.vala"
			return result;
#line 2247 "file.c"
		}
#line 273 "src/file.vala"
		confirm = TRUE;
#line 2251 "file.c"
	}
#line 276 "src/file.vala"
	if (confirm) {
#line 2255 "file.c"
		const gchar* _tmp7_;
#line 276 "src/file.vala"
		_tmp7_ = name;
#line 276 "src/file.vala"
		_tmp6_ = g_file_test (_tmp7_, G_FILE_TEST_EXISTS);
#line 2261 "file.c"
	} else {
#line 276 "src/file.vala"
		_tmp6_ = FALSE;
#line 2265 "file.c"
	}
#line 276 "src/file.vala"
	if (_tmp6_) {
#line 2269 "file.c"
		gchar* buf = NULL;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* errmsg = NULL;
		gchar* _tmp11_;
#line 277 "src/file.vala"
		_tmp8_ = name;
#line 277 "src/file.vala"
		_tmp9_ = string_to_string (_tmp8_);
#line 277 "src/file.vala"
		_tmp10_ = g_strconcat ("File `", _tmp9_, "' exists; overwrite? (y or n) ", NULL);
#line 277 "src/file.vala"
		buf = _tmp10_;
#line 278 "src/file.vala"
		_tmp11_ = g_strdup ("");
#line 278 "src/file.vala"
		errmsg = _tmp11_;
#line 2288 "file.c"
		{
			gboolean _tmp12_ = FALSE;
#line 280 "src/file.vala"
			ans = -2;
#line 280 "src/file.vala"
			_tmp12_ = TRUE;
#line 280 "src/file.vala"
			while (TRUE) {
#line 2297 "file.c"
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				Keystroke key = 0U;
				gboolean _tmp15_ = FALSE;
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
#line 280 "src/file.vala"
				if (!_tmp12_) {
#line 2306 "file.c"
				}
#line 280 "src/file.vala"
				_tmp12_ = FALSE;
#line 280 "src/file.vala"
				if (!(ans == -2)) {
#line 280 "src/file.vala"
					break;
#line 2314 "file.c"
				}
#line 281 "src/file.vala"
				_tmp13_ = errmsg;
#line 281 "src/file.vala"
				_tmp14_ = buf;
#line 281 "src/file.vala"
				minibuf_write ("%s%s", _tmp13_, _tmp14_, NULL);
#line 282 "src/file.vala"
				key = getkeystroke (GETKEY_DEFAULT);
#line 283 "src/file.vala"
				if (key == ((Keystroke) 'y')) {
#line 283 "src/file.vala"
					_tmp17_ = TRUE;
#line 2328 "file.c"
				} else {
#line 283 "src/file.vala"
					_tmp17_ = key == ((Keystroke) 'Y');
#line 2332 "file.c"
				}
#line 283 "src/file.vala"
				if (_tmp17_) {
#line 283 "src/file.vala"
					_tmp16_ = TRUE;
#line 2338 "file.c"
				} else {
#line 283 "src/file.vala"
					_tmp16_ = key == ((Keystroke) ' ');
#line 2342 "file.c"
				}
#line 283 "src/file.vala"
				if (_tmp16_) {
#line 283 "src/file.vala"
					_tmp15_ = TRUE;
#line 2348 "file.c"
				} else {
#line 283 "src/file.vala"
					_tmp15_ = key == KBD_RET;
#line 2352 "file.c"
				}
#line 283 "src/file.vala"
				if (_tmp15_) {
#line 284 "src/file.vala"
					ans = 1;
#line 2358 "file.c"
				} else {
					gboolean _tmp18_ = FALSE;
					gboolean _tmp19_ = FALSE;
#line 285 "src/file.vala"
					if (key == ((Keystroke) 'N')) {
#line 285 "src/file.vala"
						_tmp19_ = TRUE;
#line 2366 "file.c"
					} else {
#line 285 "src/file.vala"
						_tmp19_ = key == ((Keystroke) 'n');
#line 2370 "file.c"
					}
#line 285 "src/file.vala"
					if (_tmp19_) {
#line 285 "src/file.vala"
						_tmp18_ = TRUE;
#line 2376 "file.c"
					} else {
#line 285 "src/file.vala"
						_tmp18_ = key == KBD_DEL;
#line 2380 "file.c"
					}
#line 285 "src/file.vala"
					if (_tmp18_) {
#line 286 "src/file.vala"
						ans = 0;
#line 2386 "file.c"
					} else {
#line 287 "src/file.vala"
						if (key == (KBD_CTRL | 'g')) {
#line 288 "src/file.vala"
							ans = -1;
#line 2392 "file.c"
						} else {
							gchar* _tmp20_;
#line 290 "src/file.vala"
							_tmp20_ = g_strdup ("Please answer y or n.  ");
#line 290 "src/file.vala"
							_g_free0 (errmsg);
#line 290 "src/file.vala"
							errmsg = _tmp20_;
#line 2401 "file.c"
						}
					}
				}
			}
		}
#line 293 "src/file.vala"
		if (ans == -1) {
#line 294 "src/file.vala"
			funcall ("keyboard-quit", NULL, NULL);
#line 2411 "file.c"
		} else {
#line 295 "src/file.vala"
			if (ans == 0) {
#line 296 "src/file.vala"
				minibuf_error ("Canceled", NULL);
#line 2417 "file.c"
			}
		}
#line 297 "src/file.vala"
		if (ans != 1) {
#line 298 "src/file.vala"
			ok = FALSE;
#line 2424 "file.c"
		}
#line 276 "src/file.vala"
		_g_free0 (errmsg);
#line 276 "src/file.vala"
		_g_free0 (buf);
#line 2430 "file.c"
	}
#line 301 "src/file.vala"
	if (ans == 1) {
#line 2434 "file.c"
		gboolean _tmp21_ = FALSE;
		const gchar* _tmp22_;
		const gchar* _tmp26_;
#line 302 "src/file.vala"
		_tmp22_ = bp->filename;
#line 302 "src/file.vala"
		if (_tmp22_ == NULL) {
#line 302 "src/file.vala"
			_tmp21_ = TRUE;
#line 2444 "file.c"
		} else {
			const gchar* _tmp23_;
			const gchar* _tmp24_;
#line 302 "src/file.vala"
			_tmp23_ = name;
#line 302 "src/file.vala"
			_tmp24_ = bp->filename;
#line 302 "src/file.vala"
			_tmp21_ = !(g_strcmp0 (_tmp23_, _tmp24_) == 0);
#line 2454 "file.c"
		}
#line 302 "src/file.vala"
		if (_tmp21_) {
#line 2458 "file.c"
			const gchar* _tmp25_;
#line 303 "src/file.vala"
			_tmp25_ = name;
#line 303 "src/file.vala"
			buffer_set_names (bp, _tmp25_);
#line 2464 "file.c"
		}
#line 304 "src/file.vala"
		bp->needname = FALSE;
#line 305 "src/file.vala"
		bp->temporary = FALSE;
#line 306 "src/file.vala"
		bp->nosave = FALSE;
#line 307 "src/file.vala"
		_tmp26_ = name;
#line 307 "src/file.vala"
		if (backup_and_write (bp, _tmp26_)) {
#line 2476 "file.c"
			const gchar* _tmp27_;
			GList* _tmp28_;
#line 308 "src/file.vala"
			_tmp27_ = name;
#line 308 "src/file.vala"
			minibuf_write ("Wrote %s", _tmp27_, NULL);
#line 309 "src/file.vala"
			bp->modified = FALSE;
#line 310 "src/file.vala"
			_tmp28_ = bp->last_undop;
#line 310 "src/file.vala"
			undo_set_unchanged (_tmp28_);
#line 2489 "file.c"
		} else {
#line 312 "src/file.vala"
			ok = FALSE;
#line 2493 "file.c"
		}
	}
#line 315 "src/file.vala"
	result = ok;
#line 315 "src/file.vala"
	_g_free0 (name);
#line 315 "src/file.vala"
	return result;
#line 2502 "file.c"
}

gboolean
save_buffer (Buffer* bp)
{
	gboolean result;
#line 318 "src/file.vala"
	g_return_val_if_fail (bp != NULL, FALSE);
#line 319 "src/file.vala"
	if (bp->modified) {
#line 2513 "file.c"
		const gchar* _tmp0_;
#line 320 "src/file.vala"
		_tmp0_ = bp->filename;
#line 320 "src/file.vala"
		result = write_buffer (bp, bp->needname, FALSE, _tmp0_, "File to save in: ");
#line 320 "src/file.vala"
		return result;
#line 2521 "file.c"
	}
#line 322 "src/file.vala"
	minibuf_write ("(No changes need to be saved)", NULL);
#line 323 "src/file.vala"
	result = TRUE;
#line 323 "src/file.vala"
	return result;
#line 2529 "file.c"
}

static gboolean
__lambda35_ (glong uniarg,
             GeeQueue* args)
{
	gboolean ok = FALSE;
	gchar* filename = NULL;
	gpointer _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gboolean result;
#line 331 "src/file.vala"
	ok = TRUE;
#line 332 "src/file.vala"
	_tmp0_ = gee_queue_poll (args);
#line 332 "src/file.vala"
	filename = (gchar*) _tmp0_;
#line 333 "src/file.vala"
	_tmp1_ = filename;
#line 333 "src/file.vala"
	if (_tmp1_ == NULL) {
#line 2553 "file.c"
		Buffer* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 334 "src/file.vala"
		_tmp2_ = cur_bp;
#line 334 "src/file.vala"
		_tmp3_ = _tmp2_->dir;
#line 334 "src/file.vala"
		_tmp4_ = minibuf_read_filename ("Find file: ", _tmp3_, NULL, NULL);
#line 334 "src/file.vala"
		_g_free0 (filename);
#line 334 "src/file.vala"
		filename = _tmp4_;
#line 335 "src/file.vala"
		_tmp5_ = filename;
#line 335 "src/file.vala"
		if (_tmp5_ == NULL) {
#line 336 "src/file.vala"
			ok = funcall ("keyboard-quit", NULL, NULL);
#line 2574 "file.c"
		}
	}
#line 338 "src/file.vala"
	_tmp7_ = filename;
#line 338 "src/file.vala"
	if (_tmp7_ == NULL) {
#line 338 "src/file.vala"
		_tmp6_ = TRUE;
#line 2583 "file.c"
	} else {
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 338 "src/file.vala"
		_tmp8_ = filename;
#line 338 "src/file.vala"
		_tmp9_ = strlen (_tmp8_);
#line 338 "src/file.vala"
		_tmp10_ = _tmp9_;
#line 338 "src/file.vala"
		_tmp6_ = _tmp10_ == 0;
#line 2596 "file.c"
	}
#line 338 "src/file.vala"
	if (_tmp6_) {
#line 339 "src/file.vala"
		ok = FALSE;
#line 2602 "file.c"
	}
#line 341 "src/file.vala"
	if (ok) {
#line 2606 "file.c"
		const gchar* _tmp11_;
#line 342 "src/file.vala"
		_tmp11_ = filename;
#line 342 "src/file.vala"
		ok = find_file (_tmp11_);
#line 2612 "file.c"
	}
#line 344 "src/file.vala"
	result = ok;
#line 344 "src/file.vala"
	_g_free0 (filename);
#line 344 "src/file.vala"
	return result;
#line 2620 "file.c"
}

static gboolean
___lambda35__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda35_ (uniarg, args);
#line 328 "src/file.vala"
	return result;
#line 2631 "file.c"
}

static gboolean
__lambda36_ (glong uniarg,
             GeeQueue* args)
{
	gboolean ok = FALSE;
	LispFunc* _tmp0_;
	LispFunc* _tmp1_;
	Function _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 355 "src/file.vala"
	_tmp0_ = lisp_func_find ("find-file");
#line 355 "src/file.vala"
	_tmp1_ = _tmp0_;
#line 355 "src/file.vala"
	_tmp2_ = _tmp1_->func;
#line 355 "src/file.vala"
	_tmp3_ = _tmp2_ (uniarg, args);
#line 355 "src/file.vala"
	_lisp_func_unref0 (_tmp1_);
#line 355 "src/file.vala"
	ok = _tmp3_;
#line 356 "src/file.vala"
	if (ok) {
#line 2658 "file.c"
		Buffer* _tmp4_;
#line 357 "src/file.vala"
		_tmp4_ = cur_bp;
#line 357 "src/file.vala"
		_tmp4_->readonly = TRUE;
#line 2664 "file.c"
	}
#line 358 "src/file.vala"
	result = ok;
#line 358 "src/file.vala"
	return result;
#line 2670 "file.c"
}

static gboolean
___lambda36__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda36_ (uniarg, args);
#line 352 "src/file.vala"
	return result;
#line 2681 "file.c"
}

static gboolean
__lambda37_ (glong uniarg,
             GeeQueue* args)
{
	gchar* buf = NULL;
	Buffer* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* basename = NULL;
	const gchar* _tmp3_;
	gchar* ms = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean ok = FALSE;
	const gchar* _tmp12_;
	gboolean result;
#line 369 "src/file.vala"
	_tmp0_ = cur_bp;
#line 369 "src/file.vala"
	_tmp1_ = _tmp0_->filename;
#line 369 "src/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 369 "src/file.vala"
	buf = _tmp2_;
#line 370 "src/file.vala"
	basename = NULL;
#line 372 "src/file.vala"
	_tmp3_ = buf;
#line 372 "src/file.vala"
	if (_tmp3_ == NULL) {
#line 2715 "file.c"
		Buffer* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 373 "src/file.vala"
		_tmp4_ = cur_bp;
#line 373 "src/file.vala"
		_tmp5_ = _tmp4_->dir;
#line 373 "src/file.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 373 "src/file.vala"
		_g_free0 (buf);
#line 373 "src/file.vala"
		buf = _tmp6_;
#line 2729 "file.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 375 "src/file.vala"
		_tmp7_ = buf;
#line 375 "src/file.vala"
		_tmp8_ = g_path_get_basename (_tmp7_);
#line 375 "src/file.vala"
		_g_free0 (basename);
#line 375 "src/file.vala"
		basename = _tmp8_;
#line 2741 "file.c"
	}
#line 376 "src/file.vala"
	_tmp9_ = buf;
#line 376 "src/file.vala"
	_tmp10_ = basename;
#line 376 "src/file.vala"
	_tmp11_ = minibuf_read_filename ("Find alternate: ", _tmp9_, _tmp10_, NULL);
#line 376 "src/file.vala"
	ms = _tmp11_;
#line 378 "src/file.vala"
	ok = FALSE;
#line 379 "src/file.vala"
	_tmp12_ = ms;
#line 379 "src/file.vala"
	if (_tmp12_ == NULL) {
#line 380 "src/file.vala"
		ok = funcall ("keyboard-quit", NULL, NULL);
#line 2759 "file.c"
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 381 "src/file.vala"
		_tmp14_ = ms;
#line 381 "src/file.vala"
		_tmp15_ = strlen (_tmp14_);
#line 381 "src/file.vala"
		_tmp16_ = _tmp15_;
#line 381 "src/file.vala"
		if (_tmp16_ > 0) {
#line 2773 "file.c"
			Buffer* _tmp17_;
#line 381 "src/file.vala"
			_tmp17_ = cur_bp;
#line 381 "src/file.vala"
			_tmp13_ = buffer_check_modified (_tmp17_);
#line 2779 "file.c"
		} else {
#line 381 "src/file.vala"
			_tmp13_ = FALSE;
#line 2783 "file.c"
		}
#line 381 "src/file.vala"
		if (_tmp13_) {
#line 2787 "file.c"
			Buffer* _tmp18_;
			const gchar* _tmp19_;
#line 382 "src/file.vala"
			_tmp18_ = cur_bp;
#line 382 "src/file.vala"
			buffer_kill (_tmp18_);
#line 383 "src/file.vala"
			_tmp19_ = ms;
#line 383 "src/file.vala"
			ok = find_file (_tmp19_);
#line 2798 "file.c"
		}
	}
#line 385 "src/file.vala"
	result = ok;
#line 385 "src/file.vala"
	_g_free0 (ms);
#line 385 "src/file.vala"
	_g_free0 (basename);
#line 385 "src/file.vala"
	_g_free0 (buf);
#line 385 "src/file.vala"
	return result;
#line 2811 "file.c"
}

static gboolean
___lambda37__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda37_ (uniarg, args);
#line 366 "src/file.vala"
	return result;
#line 2822 "file.c"
}

static gboolean
__lambda38_ (glong uniarg,
             GeeQueue* args)
{
	Buffer* _tmp0_ = NULL;
	Buffer* _tmp1_;
	Buffer* _tmp2_;
	Buffer* bp = NULL;
	Buffer* _tmp4_;
	gboolean ok = FALSE;
	gchar* buf = NULL;
	gpointer _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp13_;
	gboolean result;
#line 396 "src/file.vala"
	_tmp1_ = cur_bp;
#line 396 "src/file.vala"
	_tmp2_ = _tmp1_->next;
#line 396 "src/file.vala"
	_tmp0_ = _tmp2_;
#line 396 "src/file.vala"
	if (_tmp0_ == NULL) {
#line 2848 "file.c"
		Buffer* _tmp3_;
#line 396 "src/file.vala"
		_tmp3_ = head_bp;
#line 396 "src/file.vala"
		_tmp0_ = _tmp3_;
#line 2854 "file.c"
	}
#line 396 "src/file.vala"
	_tmp4_ = _buffer_ref0 (_tmp0_);
#line 396 "src/file.vala"
	bp = _tmp4_;
#line 398 "src/file.vala"
	ok = TRUE;
#line 399 "src/file.vala"
	_tmp5_ = gee_queue_poll (args);
#line 399 "src/file.vala"
	buf = (gchar*) _tmp5_;
#line 400 "src/file.vala"
	_tmp6_ = buf;
#line 400 "src/file.vala"
	if (_tmp6_ == NULL) {
#line 2870 "file.c"
		Completion* cp = NULL;
		Completion* _tmp7_;
		Completion* _tmp8_;
		Buffer* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
#line 401 "src/file.vala"
		_tmp7_ = buffer_make_buffer_completion ();
#line 401 "src/file.vala"
		cp = _tmp7_;
#line 402 "src/file.vala"
		_tmp8_ = cp;
#line 402 "src/file.vala"
		_tmp9_ = bp;
#line 402 "src/file.vala"
		_tmp10_ = _tmp9_->name;
#line 402 "src/file.vala"
		_tmp11_ = minibuf_read_completion ("Switch to buffer (default %s): ", "", _tmp8_, NULL, _tmp10_, NULL);
#line 402 "src/file.vala"
		_g_free0 (buf);
#line 402 "src/file.vala"
		buf = _tmp11_;
#line 405 "src/file.vala"
		_tmp12_ = buf;
#line 405 "src/file.vala"
		if (_tmp12_ == NULL) {
#line 406 "src/file.vala"
			ok = funcall ("keyboard-quit", NULL, NULL);
#line 2900 "file.c"
		}
#line 400 "src/file.vala"
		_completion_unref0 (cp);
#line 2904 "file.c"
	}
#line 408 "src/file.vala"
	_tmp13_ = buf;
#line 408 "src/file.vala"
	if (_tmp13_ == NULL) {
#line 409 "src/file.vala"
		ok = FALSE;
#line 2912 "file.c"
	}
#line 411 "src/file.vala"
	if (ok) {
#line 2916 "file.c"
		gboolean _tmp14_ = FALSE;
		const gchar* _tmp15_;
		Buffer* _tmp30_;
#line 412 "src/file.vala"
		_tmp15_ = buf;
#line 412 "src/file.vala"
		if (_tmp15_ != NULL) {
#line 2924 "file.c"
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 412 "src/file.vala"
			_tmp16_ = buf;
#line 412 "src/file.vala"
			_tmp17_ = strlen (_tmp16_);
#line 412 "src/file.vala"
			_tmp18_ = _tmp17_;
#line 412 "src/file.vala"
			_tmp14_ = _tmp18_ > 0;
#line 2936 "file.c"
		} else {
#line 412 "src/file.vala"
			_tmp14_ = FALSE;
#line 2940 "file.c"
		}
#line 412 "src/file.vala"
		if (_tmp14_) {
#line 2944 "file.c"
			const gchar* _tmp19_;
			Buffer* _tmp20_;
			Buffer* _tmp21_;
#line 413 "src/file.vala"
			_tmp19_ = buf;
#line 413 "src/file.vala"
			_tmp20_ = buffer_find (_tmp19_);
#line 413 "src/file.vala"
			_buffer_unref0 (bp);
#line 413 "src/file.vala"
			bp = _tmp20_;
#line 414 "src/file.vala"
			_tmp21_ = bp;
#line 414 "src/file.vala"
			if (_tmp21_ == NULL) {
#line 2960 "file.c"
				Estr* _tmp22_;
				Estr* _tmp23_;
				Buffer* _tmp24_;
				Buffer* _tmp25_;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				Buffer* _tmp28_;
				Buffer* _tmp29_;
#line 415 "src/file.vala"
				_tmp22_ = estr_of_empty (IMMUTABLE_ESTR_eol_lf);
#line 415 "src/file.vala"
				_tmp23_ = _tmp22_;
#line 415 "src/file.vala"
				_tmp24_ = buffer_new (_tmp23_);
#line 415 "src/file.vala"
				_buffer_unref0 (bp);
#line 415 "src/file.vala"
				bp = _tmp24_;
#line 415 "src/file.vala"
				_immutable_estr_unref0 (_tmp23_);
#line 416 "src/file.vala"
				_tmp25_ = bp;
#line 416 "src/file.vala"
				_tmp26_ = buf;
#line 416 "src/file.vala"
				_tmp27_ = g_strdup (_tmp26_);
#line 416 "src/file.vala"
				_g_free0 (_tmp25_->name);
#line 416 "src/file.vala"
				_tmp25_->name = _tmp27_;
#line 417 "src/file.vala"
				_tmp28_ = bp;
#line 417 "src/file.vala"
				_tmp28_->needname = TRUE;
#line 418 "src/file.vala"
				_tmp29_ = bp;
#line 418 "src/file.vala"
				_tmp29_->nosave = TRUE;
#line 2999 "file.c"
			}
		}
#line 422 "src/file.vala"
		_tmp30_ = bp;
#line 422 "src/file.vala"
		buffer_switch_to (_tmp30_);
#line 3006 "file.c"
	}
#line 425 "src/file.vala"
	result = ok;
#line 425 "src/file.vala"
	_g_free0 (buf);
#line 425 "src/file.vala"
	_buffer_unref0 (bp);
#line 425 "src/file.vala"
	return result;
#line 3016 "file.c"
}

static gboolean
___lambda38__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda38_ (uniarg, args);
#line 393 "src/file.vala"
	return result;
#line 3027 "file.c"
}

static gboolean
__lambda39_ (glong uniarg,
             GeeQueue* args)
{
	Buffer* _tmp0_ = NULL;
	Buffer* _tmp1_;
	Buffer* _tmp2_;
	Buffer* def_bp = NULL;
	Buffer* _tmp4_;
	Buffer* _tmp5_;
	gboolean ok = FALSE;
	gchar* buf = NULL;
	gpointer _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp14_;
	gboolean result;
#line 434 "src/file.vala"
	_tmp1_ = cur_bp;
#line 434 "src/file.vala"
	_tmp2_ = _tmp1_->next;
#line 434 "src/file.vala"
	_tmp0_ = _tmp2_;
#line 434 "src/file.vala"
	if (_tmp0_ == NULL) {
#line 3054 "file.c"
		Buffer* _tmp3_;
#line 434 "src/file.vala"
		_tmp3_ = head_bp;
#line 434 "src/file.vala"
		_tmp0_ = _tmp3_;
#line 3060 "file.c"
	}
#line 434 "src/file.vala"
	_tmp4_ = _buffer_ref0 (_tmp0_);
#line 434 "src/file.vala"
	def_bp = _tmp4_;
#line 436 "src/file.vala"
	_tmp5_ = cur_bp;
#line 436 "src/file.vala"
	if (buffer_warn_if_readonly (_tmp5_)) {
#line 437 "src/file.vala"
		result = FALSE;
#line 437 "src/file.vala"
		_buffer_unref0 (def_bp);
#line 437 "src/file.vala"
		return result;
#line 3076 "file.c"
	}
#line 439 "src/file.vala"
	ok = TRUE;
#line 440 "src/file.vala"
	_tmp6_ = gee_queue_poll (args);
#line 440 "src/file.vala"
	buf = (gchar*) _tmp6_;
#line 441 "src/file.vala"
	_tmp7_ = buf;
#line 441 "src/file.vala"
	if (_tmp7_ == NULL) {
#line 3088 "file.c"
		Completion* cp = NULL;
		Completion* _tmp8_;
		Completion* _tmp9_;
		Buffer* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
#line 442 "src/file.vala"
		_tmp8_ = buffer_make_buffer_completion ();
#line 442 "src/file.vala"
		cp = _tmp8_;
#line 443 "src/file.vala"
		_tmp9_ = cp;
#line 443 "src/file.vala"
		_tmp10_ = def_bp;
#line 443 "src/file.vala"
		_tmp11_ = _tmp10_->name;
#line 443 "src/file.vala"
		_tmp12_ = minibuf_read_completion ("Insert buffer (default %s): ", "", _tmp9_, NULL, _tmp11_, NULL);
#line 443 "src/file.vala"
		_g_free0 (buf);
#line 443 "src/file.vala"
		buf = _tmp12_;
#line 445 "src/file.vala"
		_tmp13_ = buf;
#line 445 "src/file.vala"
		if (_tmp13_ == NULL) {
#line 446 "src/file.vala"
			ok = funcall ("keyboard-quit", NULL, NULL);
#line 3118 "file.c"
		}
#line 441 "src/file.vala"
		_completion_unref0 (cp);
#line 3122 "file.c"
	}
#line 448 "src/file.vala"
	_tmp14_ = buf;
#line 448 "src/file.vala"
	if (_tmp14_ == NULL) {
#line 449 "src/file.vala"
		ok = FALSE;
#line 3130 "file.c"
	}
#line 451 "src/file.vala"
	if (ok) {
#line 3134 "file.c"
		Buffer* bp = NULL;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
#line 454 "src/file.vala"
		_tmp16_ = buf;
#line 454 "src/file.vala"
		if (_tmp16_ != NULL) {
#line 3142 "file.c"
			const gchar* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
#line 454 "src/file.vala"
			_tmp17_ = buf;
#line 454 "src/file.vala"
			_tmp18_ = strlen (_tmp17_);
#line 454 "src/file.vala"
			_tmp19_ = _tmp18_;
#line 454 "src/file.vala"
			_tmp15_ = _tmp19_ > 0;
#line 3154 "file.c"
		} else {
#line 454 "src/file.vala"
			_tmp15_ = FALSE;
#line 3158 "file.c"
		}
#line 454 "src/file.vala"
		if (_tmp15_) {
#line 3162 "file.c"
			const gchar* _tmp20_;
			Buffer* _tmp21_;
			Buffer* _tmp22_;
#line 455 "src/file.vala"
			_tmp20_ = buf;
#line 455 "src/file.vala"
			_tmp21_ = buffer_find (_tmp20_);
#line 455 "src/file.vala"
			_buffer_unref0 (bp);
#line 455 "src/file.vala"
			bp = _tmp21_;
#line 456 "src/file.vala"
			_tmp22_ = bp;
#line 456 "src/file.vala"
			if (_tmp22_ == NULL) {
#line 3178 "file.c"
				const gchar* _tmp23_;
#line 457 "src/file.vala"
				_tmp23_ = buf;
#line 457 "src/file.vala"
				minibuf_error ("Buffer `%s' not found", _tmp23_, NULL);
#line 458 "src/file.vala"
				ok = FALSE;
#line 3186 "file.c"
			}
		} else {
			Buffer* _tmp24_;
			Buffer* _tmp25_;
#line 461 "src/file.vala"
			_tmp24_ = def_bp;
#line 461 "src/file.vala"
			_tmp25_ = _buffer_ref0 (_tmp24_);
#line 461 "src/file.vala"
			_buffer_unref0 (bp);
#line 461 "src/file.vala"
			bp = _tmp25_;
#line 3199 "file.c"
		}
#line 463 "src/file.vala"
		if (ok) {
#line 3203 "file.c"
			Buffer* _tmp26_;
			Buffer* _tmp27_;
#line 464 "src/file.vala"
			_tmp26_ = cur_bp;
#line 464 "src/file.vala"
			_tmp27_ = bp;
#line 464 "src/file.vala"
			buffer_insert_buffer (_tmp26_, _tmp27_);
#line 465 "src/file.vala"
			funcall ("set-mark-command", NULL, NULL);
#line 3214 "file.c"
		}
#line 451 "src/file.vala"
		_buffer_unref0 (bp);
#line 3218 "file.c"
	}
#line 469 "src/file.vala"
	result = ok;
#line 469 "src/file.vala"
	_g_free0 (buf);
#line 469 "src/file.vala"
	_buffer_unref0 (def_bp);
#line 469 "src/file.vala"
	return result;
#line 3228 "file.c"
}

static gboolean
___lambda39__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda39_ (uniarg, args);
#line 431 "src/file.vala"
	return result;
#line 3239 "file.c"
}

static gboolean
__lambda40_ (glong uniarg,
             GeeQueue* args)
{
	Buffer* _tmp0_;
	gboolean ok = FALSE;
	gchar* file = NULL;
	gpointer _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 479 "src/file.vala"
	_tmp0_ = cur_bp;
#line 479 "src/file.vala"
	if (buffer_warn_if_readonly (_tmp0_)) {
#line 480 "src/file.vala"
		result = FALSE;
#line 480 "src/file.vala"
		return result;
#line 3263 "file.c"
	}
#line 482 "src/file.vala"
	ok = TRUE;
#line 483 "src/file.vala"
	_tmp1_ = gee_queue_poll (args);
#line 483 "src/file.vala"
	file = (gchar*) _tmp1_;
#line 484 "src/file.vala"
	_tmp2_ = file;
#line 484 "src/file.vala"
	if (_tmp2_ == NULL) {
#line 3275 "file.c"
		Buffer* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 485 "src/file.vala"
		_tmp3_ = cur_bp;
#line 485 "src/file.vala"
		_tmp4_ = _tmp3_->dir;
#line 485 "src/file.vala"
		_tmp5_ = minibuf_read_filename ("Insert file: ", _tmp4_, NULL, NULL);
#line 485 "src/file.vala"
		_g_free0 (file);
#line 485 "src/file.vala"
		file = _tmp5_;
#line 486 "src/file.vala"
		_tmp6_ = file;
#line 486 "src/file.vala"
		if (_tmp6_ == NULL) {
#line 487 "src/file.vala"
			ok = funcall ("keyboard-quit", NULL, NULL);
#line 3296 "file.c"
		}
	}
#line 490 "src/file.vala"
	_tmp8_ = file;
#line 490 "src/file.vala"
	if (_tmp8_ == NULL) {
#line 490 "src/file.vala"
		_tmp7_ = TRUE;
#line 3305 "file.c"
	} else {
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 490 "src/file.vala"
		_tmp9_ = file;
#line 490 "src/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 490 "src/file.vala"
		_tmp11_ = _tmp10_;
#line 490 "src/file.vala"
		_tmp7_ = _tmp11_ == 0;
#line 3318 "file.c"
	}
#line 490 "src/file.vala"
	if (_tmp7_) {
#line 491 "src/file.vala"
		ok = FALSE;
#line 3324 "file.c"
	}
#line 493 "src/file.vala"
	if (ok) {
#line 3328 "file.c"
		Estr* es = NULL;
		Buffer* _tmp19_;
		Estr* _tmp20_;
		{
			Estr* _tmp12_ = NULL;
			const gchar* _tmp13_;
			Estr* _tmp14_;
			Estr* _tmp15_;
#line 496 "src/file.vala"
			_tmp13_ = file;
#line 496 "src/file.vala"
			_tmp14_ = estr_from_file (_tmp13_, &_inner_error0_);
#line 496 "src/file.vala"
			_tmp12_ = _tmp14_;
#line 496 "src/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3345 "file.c"
				goto __catch0_g_error;
			}
#line 496 "src/file.vala"
			_tmp15_ = _tmp12_;
#line 496 "src/file.vala"
			_tmp12_ = NULL;
#line 496 "src/file.vala"
			_immutable_estr_unref0 (es);
#line 496 "src/file.vala"
			es = _tmp15_;
#line 495 "src/file.vala"
			_immutable_estr_unref0 (_tmp12_);
#line 3358 "file.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 495 "src/file.vala"
			g_clear_error (&_inner_error0_);
#line 498 "src/file.vala"
			_tmp16_ = file;
#line 498 "src/file.vala"
			_tmp17_ = strerror (errno);
#line 498 "src/file.vala"
			minibuf_error ("%s: %s", _tmp16_, _tmp17_, NULL);
#line 499 "src/file.vala"
			result = FALSE;
#line 499 "src/file.vala"
			_immutable_estr_unref0 (es);
#line 499 "src/file.vala"
			_g_free0 (file);
#line 499 "src/file.vala"
			return result;
#line 3381 "file.c"
		}
		__finally0:
#line 495 "src/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3386 "file.c"
			gboolean _tmp18_ = FALSE;
#line 495 "src/file.vala"
			_immutable_estr_unref0 (es);
#line 495 "src/file.vala"
			_g_free0 (file);
#line 495 "src/file.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 495 "src/file.vala"
			g_clear_error (&_inner_error0_);
#line 495 "src/file.vala"
			return _tmp18_;
#line 3398 "file.c"
		}
#line 501 "src/file.vala"
		_tmp19_ = cur_bp;
#line 501 "src/file.vala"
		_tmp20_ = es;
#line 501 "src/file.vala"
		buffer_insert_estr (_tmp19_, (ImmutableEstr*) _tmp20_);
#line 502 "src/file.vala"
		funcall ("set-mark-command", NULL, NULL);
#line 493 "src/file.vala"
		_immutable_estr_unref0 (es);
#line 3410 "file.c"
	}
#line 504 "src/file.vala"
	result = ok;
#line 504 "src/file.vala"
	_g_free0 (file);
#line 504 "src/file.vala"
	return result;
#line 3418 "file.c"
}

static gboolean
___lambda40__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda40_ (uniarg, args);
#line 476 "src/file.vala"
	return result;
#line 3429 "file.c"
}

static gboolean
__lambda41_ (glong uniarg,
             GeeQueue* args)
{
	Buffer* _tmp0_;
	gboolean result;
#line 514 "src/file.vala"
	_tmp0_ = cur_bp;
#line 514 "src/file.vala"
	result = save_buffer (_tmp0_);
#line 514 "src/file.vala"
	return result;
#line 3444 "file.c"
}

static gboolean
___lambda41__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda41_ (uniarg, args);
#line 511 "src/file.vala"
	return result;
#line 3455 "file.c"
}

static gboolean
__lambda42_ (glong uniarg,
             GeeQueue* args)
{
	Buffer* _tmp0_;
	gboolean result;
#line 524 "src/file.vala"
	_tmp0_ = cur_bp;
#line 524 "src/file.vala"
	result = write_buffer (_tmp0_, TRUE, noarg (args), NULL, "Write file: ");
#line 524 "src/file.vala"
	return result;
#line 3470 "file.c"
}

static gboolean
___lambda42__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda42_ (uniarg, args);
#line 521 "src/file.vala"
	return result;
#line 3481 "file.c"
}

static gboolean
__lambda43_ (glong uniarg,
             GeeQueue* args)
{
	gboolean noask = FALSE;
	gboolean result;
#line 536 "src/file.vala"
	noask = FALSE;
#line 3492 "file.c"
	{
		Buffer* bp = NULL;
		Buffer* _tmp0_;
		Buffer* _tmp1_;
#line 538 "src/file.vala"
		_tmp0_ = head_bp;
#line 538 "src/file.vala"
		_tmp1_ = _buffer_ref0 (_tmp0_);
#line 538 "src/file.vala"
		bp = _tmp1_;
#line 3503 "file.c"
		{
			gboolean _tmp2_ = FALSE;
#line 538 "src/file.vala"
			_tmp2_ = TRUE;
#line 538 "src/file.vala"
			while (TRUE) {
#line 3510 "file.c"
				Buffer* _tmp7_;
				gboolean _tmp8_ = FALSE;
				Buffer* _tmp9_;
#line 538 "src/file.vala"
				if (!_tmp2_) {
#line 3516 "file.c"
					Buffer* _tmp3_;
					Buffer* _tmp4_;
					Buffer* _tmp5_;
					Buffer* _tmp6_;
#line 538 "src/file.vala"
					_tmp3_ = bp;
#line 538 "src/file.vala"
					_tmp4_ = _tmp3_->next;
#line 538 "src/file.vala"
					_tmp5_ = _buffer_ref0 (_tmp4_);
#line 538 "src/file.vala"
					_buffer_unref0 (bp);
#line 538 "src/file.vala"
					bp = _tmp5_;
#line 538 "src/file.vala"
					_tmp6_ = bp;
#line 3533 "file.c"
				}
#line 538 "src/file.vala"
				_tmp2_ = FALSE;
#line 538 "src/file.vala"
				_tmp7_ = bp;
#line 538 "src/file.vala"
				if (!(_tmp7_ != NULL)) {
#line 538 "src/file.vala"
					break;
#line 3543 "file.c"
				}
#line 539 "src/file.vala"
				_tmp9_ = bp;
#line 539 "src/file.vala"
				if (_tmp9_->modified) {
#line 3549 "file.c"
					Buffer* _tmp10_;
#line 539 "src/file.vala"
					_tmp10_ = bp;
#line 539 "src/file.vala"
					_tmp8_ = !_tmp10_->nosave;
#line 3555 "file.c"
				} else {
#line 539 "src/file.vala"
					_tmp8_ = FALSE;
#line 3559 "file.c"
				}
#line 539 "src/file.vala"
				if (_tmp8_) {
#line 3563 "file.c"
					gchar* fname = NULL;
					Buffer* _tmp11_;
					gchar* _tmp12_;
#line 540 "src/file.vala"
					_tmp11_ = bp;
#line 540 "src/file.vala"
					_tmp12_ = buffer_get_filename_or_name (_tmp11_);
#line 540 "src/file.vala"
					fname = _tmp12_;
#line 541 "src/file.vala"
					if (noask) {
#line 3575 "file.c"
						Buffer* _tmp13_;
#line 542 "src/file.vala"
						_tmp13_ = bp;
#line 542 "src/file.vala"
						save_buffer (_tmp13_);
#line 3581 "file.c"
					} else {
						{
							gboolean _tmp14_ = FALSE;
#line 544 "src/file.vala"
							_tmp14_ = TRUE;
#line 544 "src/file.vala"
							while (TRUE) {
#line 3589 "file.c"
								const gchar* _tmp15_;
								Keystroke c = 0U;
#line 544 "src/file.vala"
								if (!_tmp14_) {
#line 3594 "file.c"
								}
#line 544 "src/file.vala"
								_tmp14_ = FALSE;
#line 545 "src/file.vala"
								_tmp15_ = fname;
#line 545 "src/file.vala"
								minibuf_write ("Save file %s? (y, n, !, ., q) ", _tmp15_, NULL);
#line 546 "src/file.vala"
								c = getkey (GETKEY_DEFAULT);
#line 547 "src/file.vala"
								minibuf_clear ();
#line 549 "src/file.vala"
								if (c == KBD_CANCEL) {
#line 550 "src/file.vala"
									funcall ("keyboard-quit", NULL, NULL);
#line 551 "src/file.vala"
									result = FALSE;
#line 551 "src/file.vala"
									_g_free0 (fname);
#line 551 "src/file.vala"
									_buffer_unref0 (bp);
#line 551 "src/file.vala"
									return result;
#line 3618 "file.c"
								} else {
#line 552 "src/file.vala"
									if (c == ((Keystroke) 'q')) {
#line 553 "src/file.vala"
										result = TRUE;
#line 553 "src/file.vala"
										_g_free0 (fname);
#line 553 "src/file.vala"
										_buffer_unref0 (bp);
#line 553 "src/file.vala"
										return result;
#line 3630 "file.c"
									} else {
#line 554 "src/file.vala"
										if (c == ((Keystroke) '.')) {
#line 3634 "file.c"
											Buffer* _tmp16_;
#line 555 "src/file.vala"
											_tmp16_ = bp;
#line 555 "src/file.vala"
											save_buffer (_tmp16_);
#line 556 "src/file.vala"
											result = TRUE;
#line 556 "src/file.vala"
											_g_free0 (fname);
#line 556 "src/file.vala"
											_buffer_unref0 (bp);
#line 556 "src/file.vala"
											return result;
#line 3648 "file.c"
										} else {
#line 557 "src/file.vala"
											if (c == ((Keystroke) '!')) {
#line 3652 "file.c"
												Buffer* _tmp17_;
#line 558 "src/file.vala"
												noask = TRUE;
#line 559 "src/file.vala"
												_tmp17_ = bp;
#line 559 "src/file.vala"
												save_buffer (_tmp17_);
#line 560 "src/file.vala"
												break;
#line 3662 "file.c"
											} else {
												gboolean _tmp18_ = FALSE;
#line 561 "src/file.vala"
												if (c == ((Keystroke) ' ')) {
#line 561 "src/file.vala"
													_tmp18_ = TRUE;
#line 3669 "file.c"
												} else {
#line 561 "src/file.vala"
													_tmp18_ = c == ((Keystroke) 'y');
#line 3673 "file.c"
												}
#line 561 "src/file.vala"
												if (_tmp18_) {
#line 3677 "file.c"
													Buffer* _tmp19_;
#line 562 "src/file.vala"
													_tmp19_ = bp;
#line 562 "src/file.vala"
													save_buffer (_tmp19_);
#line 563 "src/file.vala"
													break;
#line 3685 "file.c"
												} else {
													gboolean _tmp20_ = FALSE;
													gboolean _tmp21_ = FALSE;
#line 564 "src/file.vala"
													if (c == ((Keystroke) 'n')) {
#line 564 "src/file.vala"
														_tmp21_ = TRUE;
#line 3693 "file.c"
													} else {
#line 564 "src/file.vala"
														_tmp21_ = c == KBD_RET;
#line 3697 "file.c"
													}
#line 564 "src/file.vala"
													if (_tmp21_) {
#line 564 "src/file.vala"
														_tmp20_ = TRUE;
#line 3703 "file.c"
													} else {
#line 564 "src/file.vala"
														_tmp20_ = c == KBD_DEL;
#line 3707 "file.c"
													}
#line 564 "src/file.vala"
													if (_tmp20_) {
#line 565 "src/file.vala"
														break;
#line 3713 "file.c"
													} else {
#line 567 "src/file.vala"
														minibuf_error ("Please answer y, n, !, . or q.", NULL);
#line 568 "src/file.vala"
														waitkey ();
#line 3719 "file.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
#line 539 "src/file.vala"
					_g_free0 (fname);
#line 3731 "file.c"
				}
			}
		}
#line 538 "src/file.vala"
		_buffer_unref0 (bp);
#line 3737 "file.c"
	}
#line 574 "src/file.vala"
	minibuf_write ("(No files need saving)", NULL);
#line 575 "src/file.vala"
	result = TRUE;
#line 575 "src/file.vala"
	return result;
#line 3745 "file.c"
}

static gboolean
___lambda43__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda43_ (uniarg, args);
#line 533 "src/file.vala"
	return result;
#line 3756 "file.c"
}

static gboolean
_bool_equal (const gboolean * s1,
             const gboolean * s2)
{
#line 593 "src/file.vala"
	if (s1 == s2) {
#line 593 "src/file.vala"
		return TRUE;
#line 3767 "file.c"
	}
#line 593 "src/file.vala"
	if (s1 == NULL) {
#line 593 "src/file.vala"
		return FALSE;
#line 3773 "file.c"
	}
#line 593 "src/file.vala"
	if (s2 == NULL) {
#line 593 "src/file.vala"
		return FALSE;
#line 3779 "file.c"
	}
#line 593 "src/file.vala"
	return (*s1) == (*s2);
#line 3783 "file.c"
}

static gboolean
__lambda44_ (glong uniarg,
             GeeQueue* args)
{
	gboolean result;
#line 584 "src/file.vala"
	if (!funcall ("save-some-buffers", NULL, NULL)) {
#line 585 "src/file.vala"
		result = FALSE;
#line 585 "src/file.vala"
		return result;
#line 3797 "file.c"
	}
	{
		Buffer* bp = NULL;
		Buffer* _tmp0_;
		Buffer* _tmp1_;
#line 587 "src/file.vala"
		_tmp0_ = head_bp;
#line 587 "src/file.vala"
		_tmp1_ = _buffer_ref0 (_tmp0_);
#line 587 "src/file.vala"
		bp = _tmp1_;
#line 3809 "file.c"
		{
			gboolean _tmp2_ = FALSE;
#line 587 "src/file.vala"
			_tmp2_ = TRUE;
#line 587 "src/file.vala"
			while (TRUE) {
#line 3816 "file.c"
				Buffer* _tmp6_;
				gboolean _tmp7_ = FALSE;
				Buffer* _tmp8_;
#line 587 "src/file.vala"
				if (!_tmp2_) {
#line 3822 "file.c"
					Buffer* _tmp3_;
					Buffer* _tmp4_;
					Buffer* _tmp5_;
#line 587 "src/file.vala"
					_tmp3_ = bp;
#line 587 "src/file.vala"
					_tmp4_ = _tmp3_->next;
#line 587 "src/file.vala"
					_tmp5_ = _buffer_ref0 (_tmp4_);
#line 587 "src/file.vala"
					_buffer_unref0 (bp);
#line 587 "src/file.vala"
					bp = _tmp5_;
#line 3836 "file.c"
				}
#line 587 "src/file.vala"
				_tmp2_ = FALSE;
#line 587 "src/file.vala"
				_tmp6_ = bp;
#line 587 "src/file.vala"
				if (!(_tmp6_ != NULL)) {
#line 587 "src/file.vala"
					break;
#line 3846 "file.c"
				}
#line 588 "src/file.vala"
				_tmp8_ = bp;
#line 588 "src/file.vala"
				if (_tmp8_->modified) {
#line 3852 "file.c"
					Buffer* _tmp9_;
#line 588 "src/file.vala"
					_tmp9_ = bp;
#line 588 "src/file.vala"
					_tmp7_ = !_tmp9_->needname;
#line 3858 "file.c"
				} else {
#line 588 "src/file.vala"
					_tmp7_ = FALSE;
#line 3862 "file.c"
				}
#line 588 "src/file.vala"
				if (_tmp7_) {
#line 3866 "file.c"
					{
						gboolean _tmp10_ = FALSE;
#line 589 "src/file.vala"
						_tmp10_ = TRUE;
#line 589 "src/file.vala"
						while (TRUE) {
#line 3873 "file.c"
							gboolean* ans = NULL;
							gboolean* _tmp11_;
							gboolean* _tmp12_;
#line 589 "src/file.vala"
							if (!_tmp10_) {
#line 3879 "file.c"
							}
#line 589 "src/file.vala"
							_tmp10_ = FALSE;
#line 590 "src/file.vala"
							_tmp11_ = minibuf_read_yesno ("Modified buffers exist; exit anyway? (yes or no) ", NULL);
#line 590 "src/file.vala"
							ans = _tmp11_;
#line 591 "src/file.vala"
							_tmp12_ = ans;
#line 591 "src/file.vala"
							if (_tmp12_ == NULL) {
#line 592 "src/file.vala"
								result = funcall ("keyboard-quit", NULL, NULL);
#line 592 "src/file.vala"
								_g_free0 (ans);
#line 592 "src/file.vala"
								_buffer_unref0 (bp);
#line 592 "src/file.vala"
								return result;
#line 3899 "file.c"
							} else {
								gboolean* _tmp13_;
								gboolean _tmp14_;
#line 593 "src/file.vala"
								_tmp13_ = ans;
#line 593 "src/file.vala"
								_tmp14_ = FALSE;
#line 593 "src/file.vala"
								if (_bool_equal (_tmp13_, &_tmp14_) == TRUE) {
#line 594 "src/file.vala"
									result = FALSE;
#line 594 "src/file.vala"
									_g_free0 (ans);
#line 594 "src/file.vala"
									_buffer_unref0 (bp);
#line 594 "src/file.vala"
									return result;
#line 3917 "file.c"
								}
							}
#line 595 "src/file.vala"
							_g_free0 (ans);
#line 595 "src/file.vala"
							break;
#line 3924 "file.c"
						}
					}
#line 597 "src/file.vala"
					break;
#line 3929 "file.c"
				}
			}
		}
#line 587 "src/file.vala"
		_buffer_unref0 (bp);
#line 3935 "file.c"
	}
#line 600 "src/file.vala"
	zile_exit (EXIT_SUCCESS);
#line 601 "src/file.vala"
	result = TRUE;
#line 601 "src/file.vala"
	return result;
#line 3943 "file.c"
}

static gboolean
___lambda44__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda44_ (uniarg, args);
#line 581 "src/file.vala"
	return result;
#line 3954 "file.c"
}

static gboolean
__lambda45_ (glong uniarg,
             GeeQueue* args)
{
	gboolean ok = FALSE;
	gchar* dir = NULL;
	gpointer _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp5_;
	gboolean result;
#line 610 "src/file.vala"
	ok = TRUE;
#line 611 "src/file.vala"
	_tmp0_ = gee_queue_poll (args);
#line 611 "src/file.vala"
	dir = (gchar*) _tmp0_;
#line 612 "src/file.vala"
	_tmp1_ = dir;
#line 612 "src/file.vala"
	if (_tmp1_ == NULL) {
#line 3977 "file.c"
		Buffer* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 613 "src/file.vala"
		_tmp2_ = cur_bp;
#line 613 "src/file.vala"
		_tmp3_ = _tmp2_->dir;
#line 613 "src/file.vala"
		_tmp4_ = minibuf_read_filename ("Change default directory: ", _tmp3_, NULL, NULL);
#line 613 "src/file.vala"
		_g_free0 (dir);
#line 613 "src/file.vala"
		dir = _tmp4_;
#line 3991 "file.c"
	}
#line 615 "src/file.vala"
	_tmp5_ = dir;
#line 615 "src/file.vala"
	if (_tmp5_ == NULL) {
#line 616 "src/file.vala"
		ok = funcall ("keyboard-quit", NULL, NULL);
#line 3999 "file.c"
	} else {
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 617 "src/file.vala"
		_tmp6_ = dir;
#line 617 "src/file.vala"
		_tmp7_ = strlen (_tmp6_);
#line 617 "src/file.vala"
		_tmp8_ = _tmp7_;
#line 617 "src/file.vala"
		if (_tmp8_ > 0) {
#line 4012 "file.c"
			const gchar* _tmp9_;
#line 618 "src/file.vala"
			_tmp9_ = dir;
#line 618 "src/file.vala"
			if (!g_file_test (_tmp9_, G_FILE_TEST_IS_DIR)) {
#line 4018 "file.c"
				const gchar* _tmp10_;
#line 619 "src/file.vala"
				_tmp10_ = dir;
#line 619 "src/file.vala"
				minibuf_error ("`%s' is not a directory", _tmp10_, NULL);
#line 620 "src/file.vala"
				ok = FALSE;
#line 4026 "file.c"
			} else {
				const gchar* _tmp11_;
#line 621 "src/file.vala"
				_tmp11_ = dir;
#line 621 "src/file.vala"
				if (chdir (_tmp11_) == -1) {
#line 4033 "file.c"
					const gchar* _tmp12_;
					const gchar* _tmp13_;
#line 622 "src/file.vala"
					_tmp12_ = dir;
#line 622 "src/file.vala"
					_tmp13_ = strerror (errno);
#line 622 "src/file.vala"
					minibuf_write ("%s: %s", _tmp12_, _tmp13_, NULL);
#line 623 "src/file.vala"
					ok = FALSE;
#line 4044 "file.c"
				}
			}
		}
	}
#line 626 "src/file.vala"
	result = TRUE;
#line 626 "src/file.vala"
	_g_free0 (dir);
#line 626 "src/file.vala"
	return result;
#line 4055 "file.c"
}

static gboolean
___lambda45__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda45_ (uniarg, args);
#line 607 "src/file.vala"
	return result;
#line 4066 "file.c"
}

void
file_init (void)
{
	LispFunc* _tmp0_;
	LispFunc* _tmp1_;
	LispFunc* _tmp2_;
	LispFunc* _tmp3_;
	LispFunc* _tmp4_;
	LispFunc* _tmp5_;
	LispFunc* _tmp6_;
	LispFunc* _tmp7_;
	LispFunc* _tmp8_;
	LispFunc* _tmp9_;
	LispFunc* _tmp10_;
	LispFunc* _tmp11_;
	LispFunc* _tmp12_;
	LispFunc* _tmp13_;
	LispFunc* _tmp14_;
	LispFunc* _tmp15_;
	LispFunc* _tmp16_;
	LispFunc* _tmp17_;
	LispFunc* _tmp18_;
	LispFunc* _tmp19_;
	LispFunc* _tmp20_;
	LispFunc* _tmp21_;
#line 328 "src/file.vala"
	_tmp0_ = lisp_func_new ("find-file", ___lambda35__function, TRUE, "Edit file FILENAME.\n" \
"Switch to a buffer visiting file FILENAME,\n" \
"creating one if none already exists.");
#line 328 "src/file.vala"
	_tmp1_ = _tmp0_;
#line 328 "src/file.vala"
	_lisp_func_unref0 (_tmp1_);
#line 352 "src/file.vala"
	_tmp2_ = lisp_func_new ("find-file-read-only", ___lambda36__function, TRUE, "Edit file FILENAME but don't allow changes.\n" \
"Like `find-file', but marks buffer as read-only.\n" \
"Use M-x toggle-read-only to permit editing.");
#line 352 "src/file.vala"
	_tmp3_ = _tmp2_;
#line 352 "src/file.vala"
	_lisp_func_unref0 (_tmp3_);
#line 366 "src/file.vala"
	_tmp4_ = lisp_func_new ("find-alternate-file", ___lambda37__function, TRUE, "Find the file specified by the user, select its buffer, kill previous " \
"buffer.\n" \
"If the current buffer now contains an empty file that you just visited" \
"\n" \
"(presumably by mistake), use this command to visit the file you really" \
" want.");
#line 366 "src/file.vala"
	_tmp5_ = _tmp4_;
#line 366 "src/file.vala"
	_lisp_func_unref0 (_tmp5_);
#line 393 "src/file.vala"
	_tmp6_ = lisp_func_new ("switch-to-buffer", ___lambda38__function, TRUE, "Select buffer BUFFER in the current window.");
#line 393 "src/file.vala"
	_tmp7_ = _tmp6_;
#line 393 "src/file.vala"
	_lisp_func_unref0 (_tmp7_);
#line 431 "src/file.vala"
	_tmp8_ = lisp_func_new ("insert-buffer", ___lambda39__function, TRUE, "Insert after point the contents of BUFFER.\n" \
"Puts mark after the inserted text.");
#line 431 "src/file.vala"
	_tmp9_ = _tmp8_;
#line 431 "src/file.vala"
	_lisp_func_unref0 (_tmp9_);
#line 476 "src/file.vala"
	_tmp10_ = lisp_func_new ("insert-file", ___lambda40__function, TRUE, "Insert contents of file FILENAME into buffer after point.\n" \
"Set mark after the inserted text.");
#line 476 "src/file.vala"
	_tmp11_ = _tmp10_;
#line 476 "src/file.vala"
	_lisp_func_unref0 (_tmp11_);
#line 511 "src/file.vala"
	_tmp12_ = lisp_func_new ("save-buffer", ___lambda41__function, TRUE, "Save current buffer in visited file if modified.  By default, makes th" \
"e\n" \
"previous version into a backup file if this is the first save.");
#line 511 "src/file.vala"
	_tmp13_ = _tmp12_;
#line 511 "src/file.vala"
	_lisp_func_unref0 (_tmp13_);
#line 521 "src/file.vala"
	_tmp14_ = lisp_func_new ("write-file", ___lambda42__function, TRUE, "Write current buffer into file FILENAME.\n" \
"This makes the buffer visit that file, and marks it as not modified.\n" \
"\n" \
"Interactively, confirmation is required unless you supply a prefix arg" \
"ument.");
#line 521 "src/file.vala"
	_tmp15_ = _tmp14_;
#line 521 "src/file.vala"
	_lisp_func_unref0 (_tmp15_);
#line 533 "src/file.vala"
	_tmp16_ = lisp_func_new ("save-some-buffers", ___lambda43__function, TRUE, "Save some modified file-visiting buffers.  Asks user about each one.");
#line 533 "src/file.vala"
	_tmp17_ = _tmp16_;
#line 533 "src/file.vala"
	_lisp_func_unref0 (_tmp17_);
#line 581 "src/file.vala"
	_tmp18_ = lisp_func_new ("save-buffers-kill-emacs", ___lambda44__function, TRUE, "Offer to save each buffer, then kill this Zile process.");
#line 581 "src/file.vala"
	_tmp19_ = _tmp18_;
#line 581 "src/file.vala"
	_lisp_func_unref0 (_tmp19_);
#line 607 "src/file.vala"
	_tmp20_ = lisp_func_new ("cd", ___lambda45__function, TRUE, "Make DIR become the current buffer's default directory.");
#line 607 "src/file.vala"
	_tmp21_ = _tmp20_;
#line 607 "src/file.vala"
	_lisp_func_unref0 (_tmp21_);
#line 4160 "file.c"
}

