/* keycode.c generated by valac 0.56.14, the Vala compiler
 * generated from keycode.vala, do not modify */

/* Key encoding and decoding functions

   Copyright (c) 1997-2021 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#define KBD_NOKEY ((Keystroke) G_MAXUINT)
#define KBD_CTRL ((Keystroke) 01000)
#define KBD_META ((Keystroke) 02000)
#define KBD_CANCEL (KBD_CTRL | 'g')
#define KBD_TAB ((Keystroke) 00402)
#define KBD_RET ((Keystroke) 00403)
#define KBD_PGUP ((Keystroke) 00404)
#define KBD_PGDN ((Keystroke) 00405)
#define KBD_HOME ((Keystroke) 00406)
#define KBD_END ((Keystroke) 00407)
#define KBD_DEL ((Keystroke) 00410)
#define KBD_BS ((Keystroke) 00411)
#define KBD_INS ((Keystroke) 00412)
#define KBD_LEFT ((Keystroke) 00413)
#define KBD_RIGHT ((Keystroke) 00414)
#define KBD_UP ((Keystroke) 00415)
#define KBD_DOWN ((Keystroke) 00416)
#define KBD_F1 ((Keystroke) 00420)
#define KBD_F2 ((Keystroke) 00421)
#define KBD_F3 ((Keystroke) 00422)
#define KBD_F4 ((Keystroke) 00423)
#define KBD_F5 ((Keystroke) 00424)
#define KBD_F6 ((Keystroke) 00425)
#define KBD_F7 ((Keystroke) 00426)
#define KBD_F8 ((Keystroke) 00427)
#define KBD_F9 ((Keystroke) 00430)
#define KBD_F10 ((Keystroke) 00431)
#define KBD_F11 ((Keystroke) 00432)
#define KBD_F12 ((Keystroke) 00433)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef guint Keystroke;

#define TYPE_KEY_INFO (key_info_get_type ())
typedef struct _KeyInfo KeyInfo;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef gchar* (*KeyStringifier) (Keystroke key, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _KeyInfo {
	Keystroke code;
	gchar* name;
	gchar* desc;
};

VALA_EXTERN GType key_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN KeyInfo* key_info_dup (const KeyInfo* self);
VALA_EXTERN void key_info_free (KeyInfo* self);
VALA_EXTERN void key_info_copy (const KeyInfo* self,
                    KeyInfo* dest);
VALA_EXTERN void key_info_destroy (KeyInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (KeyInfo, key_info_destroy)
VALA_EXTERN gchar* keytostr (Keystroke key);
VALA_EXTERN gchar* keytodesc (Keystroke key);
VALA_EXTERN gchar* chordtostr (Keystroke key,
                   KeyStringifier func,
                   gpointer func_target);
VALA_EXTERN gchar* chordtodesc (Keystroke key);
static gchar* _keytodesc_key_stringifier (Keystroke key,
                                   gpointer self);
VALA_EXTERN Keystroke strtokey (const gchar* buf,
                    Keystroke* len);
VALA_EXTERN Keystroke strtochord (const gchar* buf,
                      Keystroke* len);
VALA_EXTERN GeeList* keystrtovec (const gchar* key);
VALA_EXTERN gchar* keyvectostr (GeeList* keys);
static gchar* _keytostr_key_stringifier (Keystroke key,
                                  gpointer self);
VALA_EXTERN gchar* keyvectodesc (GeeList* keys);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

const KeyInfo keyinfo[34] = {{KBD_BS, "\\BACKSPACE", "<backspace>"}, {KBD_CTRL, "\\C-", "C-"}, {KBD_DEL, "\\DELETE", "<delete>"}, {KBD_DOWN, "\\DOWN", "<down>"}, {(Keystroke) 033, "\\e", NULL}, {KBD_END, "\\END", "<end>"}, {KBD_F1, "\\F1", "<f1>"}, {KBD_F10, "\\F10", "<f10>"}, {KBD_F11, "\\F11", "<f11>"}, {KBD_F12, "\\F12", "<f12>"}, {KBD_F2, "\\F2", "<f2>"}, {KBD_F3, "\\F3", "<f3>"}, {KBD_F4, "\\F4", "<f4>"}, {KBD_F5, "\\F5", "<f5>"}, {KBD_F6, "\\F6", "<f6>"}, {KBD_F7, "\\F7", "<f7>"}, {KBD_F8, "\\F8", "<f8>"}, {KBD_F9, "\\F9", "<f9>"}, {KBD_HOME, "\\HOME", "<home>"}, {KBD_INS, "\\INSERT", "<insert>"}, {KBD_LEFT, "\\LEFT", "<left>"}, {KBD_META, "\\M-", "M-"}, {KBD_PGDN, "\\NEXT", "<next>"}, {KBD_PGDN, "\\PAGEDOWN", "<pagedown>"}, {KBD_PGUP, "\\PAGEUP", "<pageup>"}, {KBD_PGUP, "\\PRIOR", "<prior>"}, {KBD_RET, "\\RET", "<RET>"}, {KBD_RET, "\\r", NULL}, {KBD_RIGHT, "\\RIGHT", "<right>"}, {(Keystroke) ' ', "\\SPC", "SPC"}, {KBD_TAB, "\\TAB", "<TAB>"}, {KBD_TAB, "\\t", NULL}, {KBD_UP, "\\UP", "<up>"}, {(Keystroke) '\\', "\\\\", "\\"}};

void
key_info_copy (const KeyInfo* self,
               KeyInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 57 "src/keycode.vala"
	(*dest).code = (*self).code;
#line 57 "src/keycode.vala"
	_tmp0_ = (*self).name;
#line 57 "src/keycode.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 57 "src/keycode.vala"
	_g_free0 ((*dest).name);
#line 57 "src/keycode.vala"
	(*dest).name = _tmp1_;
#line 57 "src/keycode.vala"
	_tmp2_ = (*self).desc;
#line 57 "src/keycode.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 57 "src/keycode.vala"
	_g_free0 ((*dest).desc);
#line 57 "src/keycode.vala"
	(*dest).desc = _tmp3_;
#line 152 "keycode.c"
}

void
key_info_destroy (KeyInfo* self)
{
#line 59 "src/keycode.vala"
	_g_free0 ((*self).name);
#line 60 "src/keycode.vala"
	_g_free0 ((*self).desc);
#line 162 "keycode.c"
}

KeyInfo*
key_info_dup (const KeyInfo* self)
{
	KeyInfo* dup;
#line 57 "src/keycode.vala"
	dup = g_new0 (KeyInfo, 1);
#line 57 "src/keycode.vala"
	key_info_copy (self, dup);
#line 57 "src/keycode.vala"
	return dup;
#line 175 "keycode.c"
}

void
key_info_free (KeyInfo* self)
{
#line 57 "src/keycode.vala"
	key_info_destroy (self);
#line 57 "src/keycode.vala"
	g_free (self);
#line 185 "keycode.c"
}

static GType
key_info_get_type_once (void)
{
	GType key_info_type_id;
	key_info_type_id = g_boxed_type_register_static ("KeyInfo", (GBoxedCopyFunc) key_info_dup, (GBoxedFreeFunc) key_info_free);
	return key_info_type_id;
}

GType
key_info_get_type (void)
{
	static volatile gsize key_info_type_id__once = 0;
	if (g_once_init_enter (&key_info_type_id__once)) {
		GType key_info_type_id;
		key_info_type_id = key_info_get_type_once ();
		g_once_init_leave (&key_info_type_id__once, key_info_type_id);
	}
	return key_info_type_id__once;
}

gchar*
keytostr (Keystroke key)
{
	gboolean _tmp6_ = FALSE;
	gchar* result;
	{
		guint i = 0U;
#line 106 "src/keycode.vala"
		i = (guint) 0;
#line 217 "keycode.c"
		{
			gboolean _tmp0_ = FALSE;
#line 106 "src/keycode.vala"
			_tmp0_ = TRUE;
#line 106 "src/keycode.vala"
			while (TRUE) {
#line 224 "keycode.c"
				KeyInfo _tmp2_;
#line 106 "src/keycode.vala"
				if (!_tmp0_) {
#line 228 "keycode.c"
					guint _tmp1_;
#line 106 "src/keycode.vala"
					_tmp1_ = i;
#line 106 "src/keycode.vala"
					i = _tmp1_ + 1;
#line 234 "keycode.c"
				}
#line 106 "src/keycode.vala"
				_tmp0_ = FALSE;
#line 106 "src/keycode.vala"
				if (!(i < ((guint) G_N_ELEMENTS (keyinfo)))) {
#line 106 "src/keycode.vala"
					break;
#line 242 "keycode.c"
				}
#line 107 "src/keycode.vala"
				_tmp2_ = keyinfo[i];
#line 107 "src/keycode.vala"
				if (_tmp2_.code == key) {
#line 248 "keycode.c"
					KeyInfo _tmp3_;
					const gchar* _tmp4_;
					gchar* _tmp5_;
#line 108 "src/keycode.vala"
					_tmp3_ = keyinfo[i];
#line 108 "src/keycode.vala"
					_tmp4_ = _tmp3_.name;
#line 108 "src/keycode.vala"
					_tmp5_ = g_strdup (_tmp4_);
#line 108 "src/keycode.vala"
					result = _tmp5_;
#line 108 "src/keycode.vala"
					return result;
#line 262 "keycode.c"
				}
			}
		}
	}
#line 109 "src/keycode.vala"
	if (key <= ((Keystroke) 0xff)) {
#line 109 "src/keycode.vala"
		_tmp6_ = g_ascii_isgraph ((gchar) key);
#line 271 "keycode.c"
	} else {
#line 109 "src/keycode.vala"
		_tmp6_ = FALSE;
#line 275 "keycode.c"
	}
#line 109 "src/keycode.vala"
	if (_tmp6_) {
#line 279 "keycode.c"
		gchar* _tmp7_;
#line 110 "src/keycode.vala"
		_tmp7_ = g_strdup_printf ("%c", (gchar) key);
#line 110 "src/keycode.vala"
		result = _tmp7_;
#line 110 "src/keycode.vala"
		return result;
#line 287 "keycode.c"
	}
#line 111 "src/keycode.vala"
	result = NULL;
#line 111 "src/keycode.vala"
	return result;
#line 293 "keycode.c"
}

gchar*
keytodesc (Keystroke key)
{
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
	gchar* result;
	{
		guint i = 0U;
#line 118 "src/keycode.vala"
		i = (guint) 0;
#line 306 "keycode.c"
		{
			gboolean _tmp0_ = FALSE;
#line 118 "src/keycode.vala"
			_tmp0_ = TRUE;
#line 118 "src/keycode.vala"
			while (TRUE) {
#line 313 "keycode.c"
				KeyInfo _tmp2_;
#line 118 "src/keycode.vala"
				if (!_tmp0_) {
#line 317 "keycode.c"
					guint _tmp1_;
#line 118 "src/keycode.vala"
					_tmp1_ = i;
#line 118 "src/keycode.vala"
					i = _tmp1_ + 1;
#line 323 "keycode.c"
				}
#line 118 "src/keycode.vala"
				_tmp0_ = FALSE;
#line 118 "src/keycode.vala"
				if (!(i < ((guint) G_N_ELEMENTS (keyinfo)))) {
#line 118 "src/keycode.vala"
					break;
#line 331 "keycode.c"
				}
#line 119 "src/keycode.vala"
				_tmp2_ = keyinfo[i];
#line 119 "src/keycode.vala"
				if (_tmp2_.code == key) {
#line 337 "keycode.c"
					KeyInfo _tmp3_;
					const gchar* _tmp4_;
					gchar* _tmp5_;
#line 120 "src/keycode.vala"
					_tmp3_ = keyinfo[i];
#line 120 "src/keycode.vala"
					_tmp4_ = _tmp3_.desc;
#line 120 "src/keycode.vala"
					_tmp5_ = g_strdup (_tmp4_);
#line 120 "src/keycode.vala"
					result = _tmp5_;
#line 120 "src/keycode.vala"
					return result;
#line 351 "keycode.c"
				}
			}
		}
	}
#line 121 "src/keycode.vala"
	if (key <= ((Keystroke) 0xff)) {
#line 121 "src/keycode.vala"
		_tmp6_ = g_ascii_isgraph ((gchar) key);
#line 360 "keycode.c"
	} else {
#line 121 "src/keycode.vala"
		_tmp6_ = FALSE;
#line 364 "keycode.c"
	}
#line 121 "src/keycode.vala"
	if (_tmp6_) {
#line 368 "keycode.c"
		gchar* _tmp7_;
#line 122 "src/keycode.vala"
		_tmp7_ = g_strdup_printf ("%c", (gchar) key);
#line 122 "src/keycode.vala"
		result = _tmp7_;
#line 122 "src/keycode.vala"
		return result;
#line 376 "keycode.c"
	}
#line 123 "src/keycode.vala"
	_tmp8_ = g_strdup_printf ("<%zx>", (gsize) key);
#line 123 "src/keycode.vala"
	result = _tmp8_;
#line 123 "src/keycode.vala"
	return result;
#line 384 "keycode.c"
}

gchar*
chordtostr (Keystroke key,
            KeyStringifier func,
            gpointer func_target)
{
	gchar* chord_string = NULL;
	gchar* _tmp0_;
	gchar* key_string = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* result;
#line 131 "src/keycode.vala"
	_tmp0_ = g_strdup ("");
#line 131 "src/keycode.vala"
	chord_string = _tmp0_;
#line 133 "src/keycode.vala"
	if ((key & KBD_CTRL) != ((Keystroke) 0)) {
#line 404 "keycode.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 134 "src/keycode.vala"
		_tmp1_ = chord_string;
#line 134 "src/keycode.vala"
		_tmp2_ = func (KBD_CTRL, func_target);
#line 134 "src/keycode.vala"
		_tmp3_ = _tmp2_;
#line 134 "src/keycode.vala"
		_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 134 "src/keycode.vala"
		_g_free0 (chord_string);
#line 134 "src/keycode.vala"
		chord_string = _tmp4_;
#line 134 "src/keycode.vala"
		_g_free0 (_tmp3_);
#line 423 "keycode.c"
	}
#line 135 "src/keycode.vala"
	if ((key & KBD_META) != ((Keystroke) 0)) {
#line 427 "keycode.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 136 "src/keycode.vala"
		_tmp5_ = chord_string;
#line 136 "src/keycode.vala"
		_tmp6_ = func (KBD_META, func_target);
#line 136 "src/keycode.vala"
		_tmp7_ = _tmp6_;
#line 136 "src/keycode.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 136 "src/keycode.vala"
		_g_free0 (chord_string);
#line 136 "src/keycode.vala"
		chord_string = _tmp8_;
#line 136 "src/keycode.vala"
		_g_free0 (_tmp7_);
#line 446 "keycode.c"
	}
#line 137 "src/keycode.vala"
	key = key & (~(KBD_CTRL | KBD_META));
#line 139 "src/keycode.vala"
	_tmp9_ = func (key, func_target);
#line 139 "src/keycode.vala"
	key_string = _tmp9_;
#line 140 "src/keycode.vala"
	_tmp10_ = key_string;
#line 140 "src/keycode.vala"
	if (_tmp10_ != NULL) {
#line 458 "keycode.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 141 "src/keycode.vala"
		_tmp11_ = chord_string;
#line 141 "src/keycode.vala"
		_tmp12_ = key_string;
#line 141 "src/keycode.vala"
		_tmp13_ = g_strconcat (_tmp11_, _tmp12_, NULL);
#line 141 "src/keycode.vala"
		result = _tmp13_;
#line 141 "src/keycode.vala"
		_g_free0 (key_string);
#line 141 "src/keycode.vala"
		_g_free0 (chord_string);
#line 141 "src/keycode.vala"
		return result;
#line 476 "keycode.c"
	}
#line 142 "src/keycode.vala"
	result = NULL;
#line 142 "src/keycode.vala"
	_g_free0 (key_string);
#line 142 "src/keycode.vala"
	_g_free0 (chord_string);
#line 142 "src/keycode.vala"
	return result;
#line 486 "keycode.c"
}

static gchar*
_keytodesc_key_stringifier (Keystroke key,
                            gpointer self)
{
	gchar* result;
	result = keytodesc (key);
#line 149 "src/keycode.vala"
	return result;
#line 497 "keycode.c"
}

gchar*
chordtodesc (Keystroke key)
{
	gchar* _tmp0_;
	gchar* result;
#line 149 "src/keycode.vala"
	_tmp0_ = chordtostr (key, _keytodesc_key_stringifier, NULL);
#line 149 "src/keycode.vala"
	result = _tmp0_;
#line 149 "src/keycode.vala"
	return result;
#line 511 "keycode.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 528 "keycode.c"
}

Keystroke
strtokey (const gchar* buf,
          Keystroke* len)
{
	Keystroke _vala_len = 0U;
	Keystroke result;
#line 155 "src/keycode.vala"
	g_return_val_if_fail (buf != NULL, 0U);
#line 156 "src/keycode.vala"
	if (string_get (buf, (glong) 0) == '\\') {
#line 541 "keycode.c"
		{
			Keystroke i = 0U;
#line 157 "src/keycode.vala"
			i = (Keystroke) 0;
#line 546 "keycode.c"
			{
				gboolean _tmp0_ = FALSE;
#line 157 "src/keycode.vala"
				_tmp0_ = TRUE;
#line 157 "src/keycode.vala"
				while (TRUE) {
#line 553 "keycode.c"
					KeyInfo _tmp2_;
					const gchar* _tmp3_;
#line 157 "src/keycode.vala"
					if (!_tmp0_) {
#line 558 "keycode.c"
						Keystroke _tmp1_;
#line 157 "src/keycode.vala"
						_tmp1_ = i;
#line 157 "src/keycode.vala"
						i = _tmp1_ + 1;
#line 564 "keycode.c"
					}
#line 157 "src/keycode.vala"
					_tmp0_ = FALSE;
#line 157 "src/keycode.vala"
					if (!(i < ((Keystroke) G_N_ELEMENTS (keyinfo)))) {
#line 157 "src/keycode.vala"
						break;
#line 572 "keycode.c"
					}
#line 158 "src/keycode.vala"
					_tmp2_ = keyinfo[i];
#line 158 "src/keycode.vala"
					_tmp3_ = _tmp2_.name;
#line 158 "src/keycode.vala"
					if (g_str_has_prefix (buf, _tmp3_)) {
#line 580 "keycode.c"
						KeyInfo _tmp4_;
						const gchar* _tmp5_;
						gint _tmp6_;
						gint _tmp7_;
						KeyInfo _tmp8_;
#line 159 "src/keycode.vala"
						_tmp4_ = keyinfo[i];
#line 159 "src/keycode.vala"
						_tmp5_ = _tmp4_.name;
#line 159 "src/keycode.vala"
						_tmp6_ = strlen (_tmp5_);
#line 159 "src/keycode.vala"
						_tmp7_ = _tmp6_;
#line 159 "src/keycode.vala"
						_vala_len = (Keystroke) _tmp7_;
#line 160 "src/keycode.vala"
						_tmp8_ = keyinfo[i];
#line 160 "src/keycode.vala"
						result = _tmp8_.code;
#line 160 "src/keycode.vala"
						if (len) {
#line 160 "src/keycode.vala"
							*len = _vala_len;
#line 604 "keycode.c"
						}
#line 160 "src/keycode.vala"
						return result;
#line 608 "keycode.c"
					}
				}
			}
		}
#line 162 "src/keycode.vala"
		_vala_len = (Keystroke) 0;
#line 163 "src/keycode.vala"
		result = KBD_NOKEY;
#line 163 "src/keycode.vala"
		if (len) {
#line 163 "src/keycode.vala"
			*len = _vala_len;
#line 621 "keycode.c"
		}
#line 163 "src/keycode.vala"
		return result;
#line 625 "keycode.c"
	} else {
#line 165 "src/keycode.vala"
		_vala_len = (Keystroke) 1;
#line 166 "src/keycode.vala"
		result = (Keystroke) string_get (buf, (glong) 0);
#line 166 "src/keycode.vala"
		if (len) {
#line 166 "src/keycode.vala"
			*len = _vala_len;
#line 635 "keycode.c"
		}
#line 166 "src/keycode.vala"
		return result;
#line 639 "keycode.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 663 "keycode.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 672 "keycode.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 691 "keycode.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 695 "keycode.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 701 "keycode.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 711 "keycode.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 719 "keycode.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 723 "keycode.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 729 "keycode.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 739 "keycode.c"
}

Keystroke
strtochord (const gchar* buf,
            Keystroke* len)
{
	Keystroke _vala_len = 0U;
	Keystroke key = 0U;
	Keystroke k = 0U;
	Keystroke result;
#line 173 "src/keycode.vala"
	g_return_val_if_fail (buf != NULL, 0U);
#line 174 "src/keycode.vala"
	key = (Keystroke) 0;
#line 174 "src/keycode.vala"
	k = (Keystroke) 0;
#line 176 "src/keycode.vala"
	_vala_len = (Keystroke) 0;
#line 758 "keycode.c"
	{
		gboolean _tmp0_ = FALSE;
#line 177 "src/keycode.vala"
		_tmp0_ = TRUE;
#line 177 "src/keycode.vala"
		while (TRUE) {
#line 765 "keycode.c"
			Keystroke l = 0U;
			gchar* _tmp2_;
			gchar* _tmp3_;
			Keystroke _tmp4_ = 0U;
			Keystroke _tmp5_;
#line 177 "src/keycode.vala"
			if (!_tmp0_) {
#line 773 "keycode.c"
				gboolean _tmp1_ = FALSE;
#line 187 "src/keycode.vala"
				if (k == KBD_CTRL) {
#line 187 "src/keycode.vala"
					_tmp1_ = TRUE;
#line 779 "keycode.c"
				} else {
#line 187 "src/keycode.vala"
					_tmp1_ = k == KBD_META;
#line 783 "keycode.c"
				}
#line 187 "src/keycode.vala"
				if (!_tmp1_) {
#line 187 "src/keycode.vala"
					break;
#line 789 "keycode.c"
				}
			}
#line 177 "src/keycode.vala"
			_tmp0_ = FALSE;
#line 180 "src/keycode.vala"
			_tmp2_ = string_substring (buf, (glong) _vala_len, (glong) -1);
#line 180 "src/keycode.vala"
			_tmp3_ = _tmp2_;
#line 180 "src/keycode.vala"
			_tmp5_ = strtokey (_tmp3_, &_tmp4_);
#line 180 "src/keycode.vala"
			l = _tmp4_;
#line 180 "src/keycode.vala"
			k = _tmp5_;
#line 180 "src/keycode.vala"
			_g_free0 (_tmp3_);
#line 181 "src/keycode.vala"
			if (k == KBD_NOKEY) {
#line 182 "src/keycode.vala"
				_vala_len = (Keystroke) 0;
#line 183 "src/keycode.vala"
				result = KBD_NOKEY;
#line 183 "src/keycode.vala"
				if (len) {
#line 183 "src/keycode.vala"
					*len = _vala_len;
#line 816 "keycode.c"
				}
#line 183 "src/keycode.vala"
				return result;
#line 820 "keycode.c"
			}
#line 185 "src/keycode.vala"
			_vala_len = _vala_len + l;
#line 186 "src/keycode.vala"
			key |= k;
#line 826 "keycode.c"
		}
	}
#line 189 "src/keycode.vala"
	result = key;
#line 189 "src/keycode.vala"
	if (len) {
#line 189 "src/keycode.vala"
		*len = _vala_len;
#line 835 "keycode.c"
	}
#line 189 "src/keycode.vala"
	return result;
#line 839 "keycode.c"
}

GeeList*
keystrtovec (const gchar* key)
{
	GeeArrayList* keys = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 196 "src/keycode.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 198 "src/keycode.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 198 "src/keycode.vala"
	keys = _tmp0_;
#line 854 "keycode.c"
	{
		Keystroke i = 0U;
		Keystroke len = 0U;
#line 199 "src/keycode.vala"
		i = (Keystroke) 0;
#line 199 "src/keycode.vala"
		len = (Keystroke) 0;
#line 862 "keycode.c"
		{
			gboolean _tmp1_ = FALSE;
#line 199 "src/keycode.vala"
			_tmp1_ = TRUE;
#line 199 "src/keycode.vala"
			while (TRUE) {
#line 869 "keycode.c"
				gint _tmp2_;
				gint _tmp3_;
				Keystroke code = 0U;
				gchar* _tmp4_;
				gchar* _tmp5_;
				Keystroke _tmp6_ = 0U;
				Keystroke _tmp7_;
				Keystroke _tmp8_;
				GeeArrayList* _tmp9_;
#line 199 "src/keycode.vala"
				if (!_tmp1_) {
#line 199 "src/keycode.vala"
					i += len;
#line 883 "keycode.c"
				}
#line 199 "src/keycode.vala"
				_tmp1_ = FALSE;
#line 199 "src/keycode.vala"
				_tmp2_ = strlen (key);
#line 199 "src/keycode.vala"
				_tmp3_ = _tmp2_;
#line 199 "src/keycode.vala"
				if (!(i < ((Keystroke) _tmp3_))) {
#line 199 "src/keycode.vala"
					break;
#line 895 "keycode.c"
				}
#line 200 "src/keycode.vala"
				_tmp4_ = string_substring (key, (glong) i, (glong) -1);
#line 200 "src/keycode.vala"
				_tmp5_ = _tmp4_;
#line 200 "src/keycode.vala"
				_tmp7_ = strtochord (_tmp5_, &_tmp6_);
#line 200 "src/keycode.vala"
				len = _tmp6_;
#line 200 "src/keycode.vala"
				_tmp8_ = _tmp7_;
#line 200 "src/keycode.vala"
				_g_free0 (_tmp5_);
#line 200 "src/keycode.vala"
				code = _tmp8_;
#line 201 "src/keycode.vala"
				if (code == KBD_NOKEY) {
#line 202 "src/keycode.vala"
					result = NULL;
#line 202 "src/keycode.vala"
					_g_object_unref0 (keys);
#line 202 "src/keycode.vala"
					return result;
#line 919 "keycode.c"
				}
#line 203 "src/keycode.vala"
				_tmp9_ = keys;
#line 203 "src/keycode.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (gpointer) ((guintptr) code));
#line 925 "keycode.c"
			}
		}
	}
#line 206 "src/keycode.vala"
	result = (GeeList*) keys;
#line 206 "src/keycode.vala"
	return result;
#line 933 "keycode.c"
}

static gchar*
_keytostr_key_stringifier (Keystroke key,
                           gpointer self)
{
	gchar* result;
	result = keytostr (key);
#line 215 "src/keycode.vala"
	return result;
#line 944 "keycode.c"
}

gchar*
keyvectostr (GeeList* keys)
{
	gchar* key_string = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 212 "src/keycode.vala"
	g_return_val_if_fail (keys != NULL, NULL);
#line 213 "src/keycode.vala"
	_tmp0_ = g_strdup ("");
#line 213 "src/keycode.vala"
	key_string = _tmp0_;
#line 959 "keycode.c"
	{
		GeeList* _keycode_list = NULL;
		gint _keycode_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _keycode_index = 0;
#line 214 "src/keycode.vala"
		_keycode_list = keys;
#line 214 "src/keycode.vala"
		_tmp1_ = _keycode_list;
#line 214 "src/keycode.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 214 "src/keycode.vala"
		_tmp3_ = _tmp2_;
#line 214 "src/keycode.vala"
		_keycode_size = _tmp3_;
#line 214 "src/keycode.vala"
		_keycode_index = -1;
#line 214 "src/keycode.vala"
		while (TRUE) {
#line 981 "keycode.c"
			gint _tmp4_;
			gint _tmp5_;
			Keystroke keycode = 0U;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 214 "src/keycode.vala"
			_keycode_index = _keycode_index + 1;
#line 214 "src/keycode.vala"
			_tmp4_ = _keycode_index;
#line 214 "src/keycode.vala"
			_tmp5_ = _keycode_size;
#line 214 "src/keycode.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 214 "src/keycode.vala"
				break;
#line 1001 "keycode.c"
			}
#line 214 "src/keycode.vala"
			_tmp6_ = _keycode_list;
#line 214 "src/keycode.vala"
			_tmp7_ = gee_list_get (_tmp6_, _keycode_index);
#line 214 "src/keycode.vala"
			keycode = (Keystroke) ((guintptr) _tmp7_);
#line 215 "src/keycode.vala"
			_tmp8_ = key_string;
#line 215 "src/keycode.vala"
			_tmp9_ = chordtostr (keycode, _keytostr_key_stringifier, NULL);
#line 215 "src/keycode.vala"
			_tmp10_ = _tmp9_;
#line 215 "src/keycode.vala"
			_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
#line 215 "src/keycode.vala"
			_g_free0 (key_string);
#line 215 "src/keycode.vala"
			key_string = _tmp11_;
#line 215 "src/keycode.vala"
			_g_free0 (_tmp10_);
#line 1023 "keycode.c"
		}
	}
#line 216 "src/keycode.vala"
	result = key_string;
#line 216 "src/keycode.vala"
	return result;
#line 1030 "keycode.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 225 "src/keycode.vala"
	if ((*length) == (*size)) {
#line 225 "src/keycode.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 225 "src/keycode.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1045 "keycode.c"
	}
#line 225 "src/keycode.vala"
	(*array)[(*length)++] = value;
#line 225 "src/keycode.vala"
	(*array)[*length] = NULL;
#line 1051 "keycode.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 1065 "keycode.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1069 "keycode.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1075 "keycode.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1080 "keycode.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1086 "keycode.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1090 "keycode.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1094 "keycode.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1098 "keycode.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1102 "keycode.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1106 "keycode.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1121 "keycode.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 1130 "keycode.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1137 "keycode.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1143 "keycode.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1151 "keycode.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1155 "keycode.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1161 "keycode.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1166 "keycode.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1172 "keycode.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1176 "keycode.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1180 "keycode.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 1186 "keycode.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1192 "keycode.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1204 "keycode.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1208 "keycode.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1212 "keycode.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 1217 "keycode.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 1225 "keycode.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1243 "keycode.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1249 "keycode.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1253 "keycode.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1261 "keycode.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1270 "keycode.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1279 "keycode.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1285 "keycode.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1293 "keycode.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1305 "keycode.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1311 "keycode.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1315 "keycode.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1323 "keycode.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1334 "keycode.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1343 "keycode.c"
	}
}

gchar*
keyvectodesc (GeeList* keys)
{
	gchar** key_strings = NULL;
	gchar** _tmp0_;
	gint key_strings_length1;
	gint _key_strings_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp10_;
	gchar* result;
#line 222 "src/keycode.vala"
	g_return_val_if_fail (keys != NULL, NULL);
#line 223 "src/keycode.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 223 "src/keycode.vala"
	key_strings = _tmp0_;
#line 223 "src/keycode.vala"
	key_strings_length1 = 0;
#line 223 "src/keycode.vala"
	_key_strings_size_ = key_strings_length1;
#line 1368 "keycode.c"
	{
		GeeList* _keycode_list = NULL;
		gint _keycode_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _keycode_index = 0;
#line 224 "src/keycode.vala"
		_keycode_list = keys;
#line 224 "src/keycode.vala"
		_tmp1_ = _keycode_list;
#line 224 "src/keycode.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 224 "src/keycode.vala"
		_tmp3_ = _tmp2_;
#line 224 "src/keycode.vala"
		_keycode_size = _tmp3_;
#line 224 "src/keycode.vala"
		_keycode_index = -1;
#line 224 "src/keycode.vala"
		while (TRUE) {
#line 1390 "keycode.c"
			gint _tmp4_;
			gint _tmp5_;
			Keystroke keycode = 0U;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			gchar* _tmp8_;
#line 224 "src/keycode.vala"
			_keycode_index = _keycode_index + 1;
#line 224 "src/keycode.vala"
			_tmp4_ = _keycode_index;
#line 224 "src/keycode.vala"
			_tmp5_ = _keycode_size;
#line 224 "src/keycode.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 224 "src/keycode.vala"
				break;
#line 1407 "keycode.c"
			}
#line 224 "src/keycode.vala"
			_tmp6_ = _keycode_list;
#line 224 "src/keycode.vala"
			_tmp7_ = gee_list_get (_tmp6_, _keycode_index);
#line 224 "src/keycode.vala"
			keycode = (Keystroke) ((guintptr) _tmp7_);
#line 225 "src/keycode.vala"
			_tmp8_ = chordtodesc (keycode);
#line 225 "src/keycode.vala"
			_vala_array_add2 (&key_strings, &key_strings_length1, &_key_strings_size_, _tmp8_);
#line 1419 "keycode.c"
		}
	}
#line 226 "src/keycode.vala"
	_tmp9_ = key_strings;
#line 226 "src/keycode.vala"
	_tmp9__length1 = key_strings_length1;
#line 226 "src/keycode.vala"
	_tmp10_ = _vala_g_strjoinv (" ", _tmp9_, (gint) _tmp9__length1);
#line 226 "src/keycode.vala"
	result = _tmp10_;
#line 226 "src/keycode.vala"
	key_strings = (_vala_array_free (key_strings, key_strings_length1, (GDestroyNotify) g_free), NULL);
#line 226 "src/keycode.vala"
	return result;
#line 1434 "keycode.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

